<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia
*  @copyright 2019 - 2020 Prestalia
*  @license   This is proprietary software thus it cannot be distributed or reselled
*/

require_once dirname(__FILE__).'/../autoload.php';

if (Tools::isSubmit('ajax')) {
    error_reporting(0);
} else {
    error_reporting(E_ALL);
}

header('Content-Description: File Transfer');
header('Content-Type: application/octet-stream; charset=utf-8');
header('Access-Control-Allow-Origin: *');
header('Cache-Control: no-cache, must-revalidate');
header('Expires: Sat, 26 Jul 1997 05:00:00 GMT');

/* Get shop id */
$idShop = (int)Tools::getValue('shop');

if (!$idShop || !is_numeric($idShop)) {
    die("Invalid shop id");
}

/* Check endpoint */
$idLang = Tools::getValue('lang');

if (!$idLang || empty($idLang)) {
    die("Invalid lang");
}

/* Check token */
$token = Tools::getValue('token');

if (!$token || $token != SniperCommon::getConfig('ajax_token', $idShop, $idLang)) {
    term(array(
        'success' => false,
        'msg'     => 'invalid_token',
    ));
}

/* Check datafeed file */
$moduleDir      = _PS_MODULE_DIR_.'sniperfast/output/';
$synonimsFile   = $idShop.'_'.$idLang.'_synonims.txt';
$exportFile     = $idShop.'_'.$idLang.'_export.csv';
$zipFile        = $idShop.'_'.$idLang.'_export.zip';

if (!file_exists($moduleDir.$exportFile)) {
    die("File not found");
}

/* Prepare ZIP file */
if (file_exists($moduleDir.$zipFile)) {
    unlink($moduleDir.$zipFile);
}

$zip = new ZipArchive();
if ($zip->open($moduleDir.$zipFile, ZipArchive::CREATE) !== true) {
    die("Could not create zip.");
}
//add the files
$zip->addFile($moduleDir.$exportFile, $exportFile);
if (file_exists($moduleDir.$synonimsFile)) {
    $zip->addFile($moduleDir.$synonimsFile, $synonimsFile);
}

$zip->close();

/* Output file */
header('Content-Disposition: attachment; filename="' . basename($moduleDir.$zipFile) . '"');
header('Content-Length: ' . filesize($moduleDir.$zipFile));
readfile($moduleDir.$zipFile);
