<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia
*  @copyright 2019 - 2020 Prestalia
*  @license   This is proprietary software thus it cannot be distributed or reselled
*/

require_once dirname(__FILE__).'/../autoload.php';

header('Content-Type: application/json; charset=utf-8');
header('Access-Control-Allow-Origin: *');
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");

$idShop = Context::getContext()->shop->id;
$idLang = Context::getContext()->language->id;
$idCustomer = Context::getContext()->customer->id;

$products = Tools::getValue('product_list');
$productPrices = array();

$context = Context::getContext();
// $tt = Tools::getToken(false);
$st = Tools::getValue('st');
$idCurrency = Tools::getValue('id_currency');

if (empty($idCurrency)) {
    $context->currency = Currency::getDefaultCurrency();
} else {
    $context->currency = new Currency($idCurrency);
}

if ($st != SniperCommon::getConfig('price_token', $idShop, $idLang)) {
    exit(Tools::jsonEncode(array(
        'success' => false,
        'msg'     => 'price_error'
    )));
}


if (_PS_VERSION_ < '1.6') {
    $context->employee = new Employee(1, null, $idShop);
} else {
    $context->employee = new Employee(1, $idLang, $idShop);
}

$customerGroup = $context->customer->id_default_group;
$priceDisplayMethod = Group::getPriceDisplayMethod($customerGroup);
$useTaxes = true;
if ($priceDisplayMethod) {
    $useTaxes = false;
}

foreach ($products as $idProd) {
    $productPrices[$idProd]['d'] =
        (float)(round(Product::getPriceStatic($idProd, $useTaxes, null, 2, null, false, false, 1, false), 2));
    $productPrices[$idProd]['d'] = number_format($productPrices[$idProd]['d'], 2, ',', '');
    $productPrices[$idProd]['s'] =
    (float)(round(Product::getPriceStatic($idProd, $useTaxes, null, 2, null, false, true, 1, false, $idCustomer), 2));
    $productPrices[$idProd]['s'] = number_format($productPrices[$idProd]['s'], 2, ',', '');
}

if (!empty($productPrices)) {
    exit(Tools::jsonEncode(array(
        'success' => true,
        'msg'     => 'price_success',
        'result'  => $productPrices
    )));
} else {
    exit(Tools::jsonEncode(array(
        'success' => false,
        'msg'     => 'price_error'
    )));
}
