<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia
*  @copyright 2019 - 2020 Prestalia
*  @license   This is proprietary software thus it cannot be distributed or reselled
*/

require_once dirname(__FILE__).'/../autoload.php';
require_once dirname(__FILE__).'/saveAppDataFunctions.php';

header('Content-Type: application/json; charset=utf-8');
header('Access-Control-Allow-Origin: *');
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");

/* Get shop id */
$idShop = (int)Tools::getValue('shop');
if (!$idShop || !is_numeric($idShop)) {
    exit(Tools::jsonEncode(array(
        'success' => false,
        'msg'     => 'invalid_shop_id'
    )));
}

/* Get language id */
$idLang = Tools::getValue('lang');
if (!$idLang) {
    exit(Tools::jsonEncode(array(
        'success' => false,
        'msg'     => 'invalid_lang'
    )));
}

/* Check token */
$token = Tools::getValue('token');
if (!$token || $token != SniperCommon::getConfig('ajax_token', $idShop, $idLang)) {
    exit(Tools::jsonEncode(array(
        'success' => false,
        'msg'     => 'invalid_token'
    )));
}

/* Check type */
$type = Tools::getValue('type');
if (!$idLang) {
    term(array(
        'success' => false,
        'msg'     => 'invalid_type',
    ));
}

$success = false;
$msg = '';
$result = null;

switch ($type) {
    case 'app_conf':
        $style = Tools::getValue('style');
        $appConfig = Tools::getValue('app_conf');
        $success = saveAppConfig($idShop, $style, $appConfig, $msg);
        break;
    case 'app_tpl_load':
        $tpl = Tools::getValue('tpl');
        $success = loadTemplateValues($idShop, $tpl, $msg, $result);
        break;
    case 'app_tpl_load_default':
        $tpl = Tools::getValue('tpl');
        $success = loadDefaultTemplateValues($idShop, $tpl, $msg, $result);
        break;
}

if ($success) {
    exit(Tools::jsonEncode(array(
        'success' => true,
        'msg'     => $msg,
        'result'  => $result
    )));
} else {
    exit(Tools::jsonEncode(array(
        'success' => false,
        'msg'     => $msg
    )));
}
