<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

namespace Prestalia\App\Api;

class Request
{
    private $data = [];
    private $type;

    public function __construct($get, $post, $type)
    {
        $this->data = array_merge($get, $post);
        $this->type = $type;
    }

    public function has($key, callable $typeChecker = null)
    {
        if (!is_callable($typeChecker)) {
            return isset($this->data[$key]);
        }

        return isset($this->data[$key])
            && $typeChecker($this->data[$key]);
    }

    public function get($key)
    {
        if ($this->has($key)) {
            return $this->data[$key];
        }
        return null;
    }

    public function set($key, $value)
    {
        $this->data[$key] = $value;
    }

    public function getAll()
    {
        return $this->data;
    }

    public function isGet()
    {
        return $this->type == 'get';
    }

    public function isPost()
    {
        return $this->type == 'post';
    }
}
