<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

namespace Prestalia\App\Api\Handlers;

require_once 'Handler.php';
require_once 'Request.php';
require_once 'helpers.php';

use \Prestalia\App\Api\Handler;
use \Prestalia\App\Api\Request;

use \Db;

class GetAttributeGroupsHandler implements Handler
{
    public function __constructor()
    {
    }

    public function handle(Request $request)
    {
        if (!$request->has('id_lang', 'is_numeric')) {
            return error('invalid_id_lang');
        }

        if (!$request->has('id_product', 'is_numeric')) {
            return error('invalid_id_product');
        }

        $id_lang = (int)$request->get('id_lang');
        $id_product = (int)$request->get('id_product');
        $p = _DB_PREFIX_;
        $sql = "SELECT DISTINCT pagl.id_attribute_group, pagl.name as group_name
            FROM {$p}attribute_group_lang pagl
            JOIN {$p}attribute_group pag
            ON pag.id_attribute_group = pagl.id_attribute_group
            JOIN {$p}attribute pa
            ON pa.id_attribute_group = pag.id_attribute_group
            JOIN {$p}product_attribute_combination ppac
            ON ppac.id_attribute = pa.id_attribute
            JOIN {$p}product_attribute ppa
            ON ppa.id_product_attribute = ppac.id_product_attribute
            WHERE id_lang = {$id_lang}
            AND ppa.id_product = {$id_product}";

        $res = Db::getInstance()->executeS($sql);

        if (!$res) {
            return ['groups' => []];
        }

        $out = [];

        foreach ($res as $e) {
            $out[] = [
                'idAttributeGroup' => (int)$e['id_attribute_group'],
                'name' => $e['group_name']
            ];
        }

        return ['groups' => $out];
    }
}
