<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

namespace Prestalia\App\Api\Handlers;

require_once 'Handler.php';
require_once 'Request.php';
require_once 'helpers.php';

use \Prestalia\App\Api\Handler;
use \Prestalia\App\Api\Request;

use \Db;

class GetCartStatusHandler implements Handler
{
    public function __constructor()
    {
    }

    public function handle(Request $request)
    {
        if (!$request->has('id_cart', 'is_numeric')) {
            return error('Invalid or missing id_cart');
        }

        $cartId = (int)$request->get('id_cart');

        $p = _DB_PREFIX_;
        $sql = "select c.id_cart, o.id_order from {$p}cart c
            left join {$p}orders as o on c.id_cart = o.id_cart
            where c.id_cart = {$cartId}";
        $res = Db::getInstance()->executeS($sql);

        if (!$res) {
            return error('cart_not_found');
        }

        $cart = array_shift($res);

        return [
            'cart' => [
                'id' => (int)$cart['id_cart'],
                'id_order' => (int)$cart['id_order']
            ]
        ];
    }
}
