<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

namespace Prestalia\App\Api\Handlers;

require_once 'Handler.php';
require_once 'Request.php';
require_once 'helpers.php';

use \Prestalia\App\Api\Handler;
use \Prestalia\App\Api\Request;

use \Db;
use \SniperCommon;

class GetContactInfoPagesHandler implements Handler
{
    public function __constructor()
    {
    }

    public function handle(Request $request)
    {
        if (!$request->has('id_shop', 'is_numeric')) {
            return error('Invalid or missing id_shop');
        }
        if (!$request->has('id_lang', 'is_numeric')) {
            return error('Invalid or missing id_lang');
        }

        $shopId = (int)$request->get('id_shop');

        $sql = "SELECT conf_key, conf_value FROM "._DB_PREFIX_."sniperfast_app".
            " WHERE id_shop = ".(int)$shopId.
            " AND conf_key LIKE 'app_contact_%'";
        $res = Db::getInstance()->executeS($sql);

        $contactData = array(
            'app_contact_whatsapp' => '',
            'app_contact_phone' => '',
            'app_contact_gmaps' => '',
            'app_contact_email' => ''
        );

        if (!empty($res)) {
            foreach ($res as $r) {
                $contactData[$r['conf_key']] = $r['conf_value'];
            }
        }

        $response = ['contacts' => []];
        // foreach ($contactData as $contact) {
        $response['contacts'] = [
            'whatsapp' => $contactData['app_contact_whatsapp'],
            'mail' => $contactData['app_contact_email'],
            'map' => $contactData['app_contact_gmaps'],
            'phoneNumber' => $contactData['app_contact_phone']
        ];
        // }

        return $response;
    }
}
