<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

namespace Prestalia\App\Api\Handlers;

require_once 'Handler.php';
require_once 'Request.php';
require_once 'helpers.php';

use \Prestalia\App\Api\Handler;
use \Prestalia\App\Api\Request;

use \Db;

class GetCurrenciesHandler implements Handler
{
    public function __constructor()
    {
    }

    public function handle(Request $request)
    {
        unset($request);
        $p = _DB_PREFIX_;
        $sql = "SELECT c.id_currency, c.iso_code, c.name
            FROM {$p}currency c
            WHERE c.active=1";
        $res = Db::getInstance()->executeS($sql);

        if (!$res) {
            return error('no_currency_found');
        }

        $out = [];
        foreach ($res as $currency) {
            $out[] = [
                'id'   => (int)$currency['id_currency'],
                'name' => $currency['name'],
                'code' => $currency['iso_code']
            ];
        }

        return ['currencies' => $out];
    }
}
