<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

namespace Prestalia\App\Api\Handlers;

require_once 'Handler.php';
require_once 'Request.php';
require_once 'helpers.php';

use \Prestalia\App\Api\Handler;
use \Prestalia\App\Api\Request;

use \Contact;

class GetCustomerMessageReasonsHandler implements Handler
{
    public function __constructor()
    {
    }

    public function handle(Request $request)
    {
        if (!$request->has('id_lang', 'is_numeric')) {
            return error('invalid_lang_id');
        }

        $langId = (int)$request->get('id_lang');

        $reasons = Contact::getContacts($langId);
        $response = ['reasons' => []];
        foreach ($reasons as $reason) {
            $response['reasons'][] = [
                'id' => (int)$reason['id_contact'],
                'name' => $reason['name']
            ];
        }

        return $response;
    }
}
