<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

namespace Prestalia\App\Api\Handlers;

require_once 'Handler.php';
require_once 'Request.php';
require_once 'helpers.php';

use \Prestalia\App\Api\Handler;
use \Prestalia\App\Api\Request;

use \Db;

class GetReviewsHandler implements Handler
{
    public function __constructor()
    {
    }

    public function handle(Request $request)
    {
        if (!$request->has('id_product', 'is_numeric')) {
            return error('invalid_id_product');
        }

        $id_product = (int)$request->get('id_product');

        $rating = 0;
        $append = '';
        if ($request->has('rating', 'is_numeric')) {
            $requestRating = (int)$request->get('rating');
            if ($requestRating <= 6) {
                $rating = $requestRating;
                $append = ' AND grade = '.$rating;
            }
        }

        // limit to 20 reviews max
        $sql = 'SELECT *
        FROM '._DB_PREFIX_.'iqitreviews_products
        WHERE status = 1 AND id_product = '.(int)$id_product.$append.
        ' ORDER BY date_add DESC LIMIT 5';

        $query = Db::getInstance()->executeS($sql);

        $result = array();

        if (!$query) {
            return ['reviews' => $result];
        } else {
            foreach ($query as $tmp) {
                $review = array();
                $review['user'] = $tmp['customer_name'];
                $review['date'] = $tmp['date_add'];
                $review['title'] = ($tmp['title'] != '') ? $tmp['title'] : 'Recensione';
                $review['description'] = $tmp['content'];
                $review['rating'] = $tmp['rating'];
                array_push($result, $review);
            }
        }

        return ['reviews' => $result];
    }
}
