<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

namespace Prestalia\App\Api\Handlers;

require_once 'Handler.php';
require_once 'Request.php';
require_once 'helpers.php';

use \Prestalia\App\Api\Handler;
use \Prestalia\App\Api\Request;

use \Db;

class GetSearchLanguagesHandler implements Handler
{
    public function __constructor()
    {
    }
    
    public function handle(Request $request)
    {
        if (!$request->has('id_shop', 'is_numeric')) {
            return error('invalid_shop_id');
        }

        $shopId = (int)$request->get('id_shop');
        $p = _DB_PREFIX_;
        $sql = "select id_lang as id, name, iso_code as code from {$p}lang
            where id_lang
            in (select distinct id_lang from {$p}sniperfast_conf where id_shop = {$shopId})";
        $res = Db::getInstance()->executeS($sql);

        $languages = ['languages' => []];
        foreach ($res as $lang) {
            $languages['languages'][] = [
                'id' => (int)$lang['id'],
                'name' => $lang['name'],
                'code' => $lang['code']
            ];
        }

        return $languages;
    }
}
