<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

namespace Prestalia\App\Api\Handlers;

require_once 'Handler.php';
require_once 'Request.php';
require_once 'helpers.php';

use \Prestalia\App\Api\Handler;
use \Prestalia\App\Api\Request;

use \Db;
use \Customer;
use \pSQL;

class UpdateFirebaseTokenHandler implements Handler
{
    public function __constructor()
    {
    }

    public function handle(Request $request)
    {
        if (!$request->has('id_customer', 'is_numeric')) {
            return error('invalid_id_customer');
        }

        if (!$request->has('id_shop', 'is_numeric')) {
            return error('invalid_id_shop');
        }

        if (!$request->has('secure_key')) {
            return error('invalid_key');
        }

        if (!$request->has('firebase_token', 'is_string')) {
            return error('invalid_token');
        }

        $id_customer = (int)$request->get('id_customer');
        $id_shop = (int)$request->get('id_shop');
        $token = pSQL($request->get('firebase_token'));

        $customer = new Customer($id_customer);

        if ($customer->secure_key != $request->get('secure_key')) {
            return error('invalid_key');
        }

        $p = _DB_PREFIX_;
        $sql = "INSERT IGNORE INTO {$p}sniperfast_app_token (id_shop, id_customer, token)
            VALUES ({$id_shop}, {$id_customer}, '{$token}')";
        Db::getInstance()->execute($sql);

        return ['response' => 'success'];
    }
}
