<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

function error(string $message)
{
    return ['error' => $message];
}

function success($message = true)
{
    return ['success' =>  $message];
}

function getCookie($name)
{
    $cookies = [];
    $headers = headers_list();

    if (empty($headers) || !$headers) {
        return false;
    }

    // see http://tools.ietf.org/html/rfc6265#section-4.1.1
    foreach ($headers as $header) {
        if (strpos($header, 'Set-Cookie: ') === 0) {
            $value = str_replace('&', urlencode('&'), Tools::substr($header, 12));
            parse_str(current(explode(';', $value, 1)), $pair);
            $cookies = array_merge_recursive($cookies, $pair);
        }
    }

    return $cookies[$name];
}
