<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

require_once dirname(__FILE__).'/../../config/config.inc.php';

define('CDN_PROTOCOL', 'https');
define('CDN_ENDPOINT', 'com');

// legacy autoloader
spl_autoload_register(function ($class) {
    if ($class === 'AdminSniperfast') {
        require dirname(__FILE__).'/controllers/admin/AdminSniperfast.php';
        return true;
    }
    if ($class === 'Sniperfast') {
        require dirname(__FILE__).'/sniperfast.php';
        return true;
    }

    $base_dir = dirname(__FILE__).'/classes/';
    if (strpos($class, '\\') === false && strpos($class, 'Sniper') === 0) {
        $file = $base_dir . $class . '.php';
        if (file_exists($file)) {
            require $file;
        }
    }

    if ($class == 'Estimateddelivery' && Module::isInstalled('estimateddelivery')) {
        require _PS_MODULE_DIR_.'estimateddelivery/estimateddelivery.php';
        return true;
    }
});

// PSR4 autoloader
require_once dirname(__FILE__).'/lib/autoload.php';
