<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

class SniperCommonApp
{
    public static function setAppBanner(
        $idBanner,
        $idShop,
        $bannerLang,
        $bannerTitle,
        $bannerLogo,
        $bannerSource,
        $bannerSourceData,
        $bannerRandom
    ) {
        $dbp = _DB_PREFIX_;
        $db = Db::getInstance();
        $cleanData = self::getCleanData($bannerSourceData);

        if (empty($idBanner)) {
            $sql = "SELECT MAX(position)
                FROM "._DB_PREFIX_."sniperfast_app_banner";
            $max = Db::getInstance()->getValue($sql);
            $position = 0;
            if (is_numeric($max)) {
                $position = $max + 1;
            }

            $sql = "INSERT INTO {$dbp}sniperfast_app_banner
                (id_shop, id_lang, name, image, position, source, source_data, random) VALUES (".
                (int)$idShop.", ".
                (int)$bannerLang.", ".
                "'".pSQL($bannerTitle)."', ".
                "'".pSQL($bannerLogo)."', ".
                (int)$position.", ".
                (int)$bannerSource.", ".
                $cleanData.", ".
                (int)$bannerRandom.
                ")";
        } else {
            $imageSql = '';
            if (!empty($bannerLogo)) {
                $imageSql = "image = '".pSQL($bannerLogo)."', ";
            }

            $sql = "UPDATE {$dbp}sniperfast_app_banner
                SET id_lang = ".(int)$bannerLang.", ".
                    "name = '".pSQL($bannerTitle)."', ".
                    $imageSql.
                    "source = ".(int)$bannerSource.", ".
                    "source_data = ".$cleanData.", ".
                    "random = ".(int)$bannerRandom.
                " WHERE id_banner = ".(int)$idBanner.
                " AND id_shop = ".(int)$idShop;
        }

        $db->execute($sql);
    }

    public static function setAppSlider(
        $idSlider,
        $idShop,
        $sliderLang,
        $sliderTitle,
        $sliderSource,
        $sliderSourceData,
        $sliderRandom
    ) {
        $dbp = _DB_PREFIX_;
        $db = Db::getInstance();
        $cleanData = self::getCleanData($sliderSourceData);

        if (empty($idSlider)) {
            $sql = "SELECT MAX(position)
                FROM "._DB_PREFIX_."sniperfast_app_slider";
            $max = Db::getInstance()->getValue($sql);
            $position = 0;
            if (is_numeric($max)) {
                $position = $max + 1;
            }

            $sql = "INSERT INTO {$dbp}sniperfast_app_slider
                (id_shop, id_lang, name, position, source, source_data, random) VALUES (".
                (int)$idShop.", ".
                (int)$sliderLang.", ".
                "'".pSQL($sliderTitle)."', ".
                (int)$position.", ".
                (int)$sliderSource.", ".
                $cleanData.", ".
                (int)$sliderRandom.
                ")";
        } else {
            $sql = "UPDATE {$dbp}sniperfast_app_slider
                SET id_lang = ".(int)$sliderLang.", ".
                    "name = '".pSQL($sliderTitle)."', ".
                    "source = ".(int)$sliderSource.", ".
                    "source_data = ".$cleanData.", ".
                    "random = ".(int)$sliderRandom.
                " WHERE id_slider = ".(int)$idSlider.
                " AND id_shop = ".(int)$idShop;
        }

        $db->execute($sql);
    }

    public static function setAppNotification(
        $idNotification,
        $idShop,
        $notificationLang,
        $notificationTitle,
        $notificationBody,
        $notificationDate,
        $topic
    ) {
        $dbp = _DB_PREFIX_;
        $db = Db::getInstance();

        if (empty($idNotification)) {
            $sql = "INSERT INTO {$dbp}sniperfast_app_notification
                (id_shop, id_lang, title, body, time, topic) VALUES (".
                (int)$idShop.", ".
                (int)$notificationLang.", ".
                "'".pSQL($notificationTitle)."', ".
                "'".pSQL($notificationBody)."', ".
                "'".pSQL($notificationDate)."', ".
                "'".pSQL($topic)."'".
                ")";
        } else {
            $sql = "UPDATE {$dbp}sniperfast_app_notification
                SET id_lang = ".(int)$notificationLang.", ".
                    "title = '".pSQL($notificationTitle)."', ".
                    "body = '".pSQL($notificationBody)."', ".
                    "time = '".pSQL($notificationDate)."', ".
                    "topic = '".pSQL($topic)."'".
                " WHERE id_notification = ".(int)$idNotification.
                " AND id_shop = ".(int)$idShop;
        }

        $db->execute($sql);
        if (empty($idNotification)) {
            $idNotification = $db->Insert_ID();
        }

        return $idNotification;
    }

    public static function setAppNotificationOrder(
        $idNotification,
        $idShop,
        $notificationLang,
        $notificationTitle,
        $notificationTime,
        $notificationStatus
    ) {
        $dbp = _DB_PREFIX_;
        $db = Db::getInstance();

        if (empty($idNotification)) {
            $sql = "INSERT INTO {$dbp}sniperfast_app_notification_order
                (id_shop, id_lang, status, name, time) VALUES (".
                (int)$idShop.", ".
                (int)$notificationLang.", ".
                (int)$notificationStatus.", ".
                "'".pSQL($notificationTitle)."', ".
                "'".pSQL($notificationTime)."'".
                ")";
        } else {
            $sql = "UPDATE {$dbp}sniperfast_app_notification_order
                SET id_lang = ".(int)$notificationLang.", ".
                    "name = '".pSQL($notificationTitle)."', ".
                    "time = '".pSQL($notificationTime)."', ".
                    "status = ".(int)$notificationStatus.
                " WHERE id_notification_order = ".(int)$idNotification.
                " AND id_shop = ".(int)$idShop;
        }

        $db->execute($sql);
    }

    public static function getAppBanner($idBanner, $idShop)
    {
        $sql = "SELECT * FROM "._DB_PREFIX_."sniperfast_app_banner
            WHERE id_banner = ".(int)$idBanner.
            " AND id_shop = ".(int)$idShop;
        $res = Db::getInstance()->executeS($sql);
        if (empty($res)) {
            return array();
        } else {
            return $res[0];
        }
    }

    public static function getAllAppBanners($idShop, $idLang)
    {
        $sql = "SELECT * FROM "._DB_PREFIX_."sniperfast_app_banner".
            " WHERE id_lang = ".(int)$idLang.
            " AND id_shop = ".(int)$idShop.
            " AND enabled = 1".
            " ORDER BY position";
        $res = Db::getInstance()->executeS($sql);
        if (empty($res)) {
            return array();
        } else {
            return $res;
        }
    }

    public static function getAllAppSlider($idShop, $idLang)
    {
        $sql = "SELECT * FROM "._DB_PREFIX_."sniperfast_app_slider".
            " WHERE id_lang = ".(int)$idLang.
            " AND id_shop = ".(int)$idShop.
            " AND enabled = 1".
            " ORDER BY position";
        $res = Db::getInstance()->executeS($sql);
        if (empty($res)) {
            return array();
        } else {
            return $res;
        }
    }

    public static function getAppSlider($idSlider, $idShop)
    {
        $sql = "SELECT * FROM "._DB_PREFIX_."sniperfast_app_slider
            WHERE id_slider = ".(int)$idSlider.
            " AND id_shop = ".(int)$idShop;
        $res = Db::getInstance()->executeS($sql);
        if (empty($res)) {
            return array();
        } else {
            return $res[0];
        }
    }

    public static function getAppNotification($idNotification, $idShop)
    {
        $sql = "SELECT * FROM "._DB_PREFIX_."sniperfast_app_notification
            WHERE id_notification = ".(int)$idNotification.
            " AND id_shop = ".(int)$idShop;
        $res = Db::getInstance()->executeS($sql);
        if (empty($res)) {
            return array();
        } else {
            return $res[0];
        }
    }

    public static function getAppNotificationOrder($idNotification, $idShop)
    {
        $sql = "SELECT * FROM "._DB_PREFIX_."sniperfast_app_notification_order
            WHERE id_notification_order = ".(int)$idNotification.
            " AND id_shop = ".(int)$idShop;
        $res = Db::getInstance()->executeS($sql);
        if (empty($res)) {
            return array();
        } else {
            return $res[0];
        }
    }

    public static function deleteBanner($idBanner)
    {
        if (!is_numeric($idBanner) || $idBanner < 1) {
            return false;
        }

        $sql = "DELETE FROM "._DB_PREFIX_."sniperfast_app_banner
            WHERE id_banner = ".(int)$idBanner;
        if (Db::getInstance()->execute($sql)) {
            self::cleanPositions($idBanner, 'banner');
            return true;
        } else {
            return false;
        }
    }

    public static function deleteSlider($idSlider)
    {
        if (!is_numeric($idSlider) || $idSlider < 1) {
            return false;
        }

        $sql = "DELETE FROM "._DB_PREFIX_."sniperfast_app_slider
            WHERE id_slider = ".(int)$idSlider;
        if (Db::getInstance()->execute($sql)) {
            self::cleanPositions($idSlider, 'slider');
            return true;
        } else {
            return false;
        }
    }

    public static function deleteNotification($idNotification)
    {
        if (!is_numeric($idNotification) || $idNotification < 1) {
            return false;
        }

        $sql = "DELETE FROM "._DB_PREFIX_."sniperfast_app_notification
            WHERE id_notification = ".(int)$idNotification;
        return Db::getInstance()->execute($sql);
    }

    public static function deleteNotificationOrder($idNotification)
    {
        if (!is_numeric($idNotification) || $idNotification < 1) {
            return false;
        }

        $sql = "DELETE FROM "._DB_PREFIX_."sniperfast_app_notification_order
            WHERE id_notification_order = ".(int)$idNotification;
        return Db::getInstance()->execute($sql);
    }

    public static function getCleanData($sourceData)
    {
        if (empty($sourceData)) {
            return 'NULL';
        }
        $explData = explode(',', $sourceData);
        $cleanData = array();
        foreach ($explData as $exp) {
            $exp = trim($exp);
            if (is_numeric($exp)) {
                $cleanData[] = $exp;
            }
        }

        $cleanData = implode(',', $cleanData);
        if (empty($cleanData)) {
            return 'NULL';
        }

        return "'".pSQL($cleanData)."'";
    }

    public static function cleanPositions($idElement, $type)
    {
        Db::getInstance()->execute('SET @i = -1', false);
        $sql = 'UPDATE `'._DB_PREFIX_.'sniperfast_app_'.pSQL($type).'`
            SET `position` = @i:=@i+1 WHERE'.
            ' `id_'.pSQL($type).'` != '.(int)$idElement.' ORDER BY `position` ASC';

        return Db::getInstance()->execute($sql);
    }

    public static function updatePositions($idElement, $type, $position, $way)
    {
        $sql = '
			SELECT a.`id_'.pSQL($type).'`, a.`position`
			FROM `'._DB_PREFIX_.'sniperfast_app_'.pSQL($type).'` a
			ORDER BY a.`position` ASC';

        if (!$res = Db::getInstance()->executeS($sql)) {
            return false;
        }

        foreach ($res as $element) {
            if ((int) $element['id_'.$type] == (int)$idElement) {
                $movedElement = $element;
            }
        }

        if (!isset($movedElement) || !isset($position)) {
            return false;
        }

        $sql1 = 'UPDATE `'._DB_PREFIX_.
            'sniperfast_app_'.pSQL($type).'`
			SET `position`= `position` '.($way ? '- 1' : '+ 1').'
			WHERE `position`
			'.($way
                ? '> '.(int) $movedElement['position'].' AND `position` <= '.(int) $position
                : '< '.(int) $movedElement['position'].' AND `position` >= '.(int) $position);

        $res1 = Db::getInstance()->execute($sql1);

        $sql2 = 'UPDATE `'._DB_PREFIX_.
            'sniperfast_app_'.pSQL($type).'`
			SET `position` = '.(int) $position.'
			WHERE `id_'.pSQL($type).'` = '.(int) $movedElement['id_'.$type];

        $res2 = Db::getInstance()->execute($sql2);

        return ($res1 && $res2);
    }

    public static function changeActivationStatus($idElement, $type)
    {
        $sql = "SELECT enabled FROM "._DB_PREFIX_."sniperfast_app_".pSQL($type).
            " WHERE id_".pSQL($type)." = ".(int)$idElement;
        $status = Db::getInstance()->getValue($sql);

        $newStatus = 0;
        if ($status == 0) {
            $newStatus = 1;
        }

        $sql = "UPDATE "._DB_PREFIX_."sniperfast_app_".pSQL($type).
            " SET enabled = ".(int)$newStatus.
            " WHERE id_".pSQL($type)." = ".(int)$idElement;
        return Db::getInstance()->execute($sql);
    }

    public static function getDeviceOs()
    {
        $out = array(
            1 => 'Android',
            2 => 'iOs'
        );

        return $out;
    }

    public static function getCategoryPathForQuery($sourceData)
    {
        if (Tools::version_compare(_PS_VERSION_, '1.7.0.0', '>=')) {
            $path = Tools::getPath('', $sourceData);
        } else {
            $path = Tools::getPath($sourceData);
        }
        $path = strip_tags($path);
        $path = str_replace(Configuration::get('PS_NAVIGATION_PIPE'), ' > ', $path);
        $explodedPath = explode(' > ', $path);
        if (Tools::version_compare(_PS_VERSION_, '1.7.0.0', '>=')) {
            if (count($explodedPath) > 1) {
                $explodedPath = array_slice($explodedPath, 1);
            }
        }
        $explodedPath = array_filter(array_map('trim', $explodedPath));
        $params = array();
        $i = 1;
        foreach ($explodedPath as $element) {
            if ($i == 5) {
                break;
            }
            $params['cat'.$i] = $element;
            $i++;
        }

        return $params;
    }

    public static function getManufacturerForQuery($sourceData)
    {
        $sql = "SELECT name FROM "._DB_PREFIX_."manufacturer
            WHERE id_manufacturer = ".(int)$sourceData;
        $mName = Db::getInstance()->getValue($sql);
        $params = array();
        if (!empty($mName)) {
            $params['snmanu'] = $mName;
        }
        return $params;
    }
}
