<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

require_once dirname(__FILE__).'/../autoload.php';

class SniperNotificationHandler
{
    private $idShop;
    private $idLang;
    private $idNotification;

    public function __construct($idShop, $idLang, $idNotification)
    {
        $this->idShop = $idShop;
        $this->idLang = $idLang;
        $this->idNotification = $idNotification;
    }

    public function sendNotification()
    {
        $notification = SniperCommonApp::getAppNotification($this->idNotification, $this->idShop);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, CDN_PROTOCOL."://api.sniperfast.".CDN_ENDPOINT."/app_sendnotification");
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query(array(
            'shop'  => $this->idShop,
            'lang'  => $this->idLang,
            'key'   => SniperCommon::getConfig('sniper_key', $this->idShop, $this->idLang),
            'name' => SniperCommon::getConfig('sniper_index_name', $this->idShop, $this->idLang),
            'title' => $notification['title'],
            'body' => $notification['body']
        )));

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $res = curl_exec($ch);
        curl_close($ch);
        $res = Tools::jsonDecode($res, true);

        return $res;
    }

    public function sendOrderNotification($orderNotification, $customerTokens)
    {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, CDN_PROTOCOL."://api.sniperfast.".CDN_ENDPOINT."/app_sendnotification");
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query(array(
            'shop'  => $this->idShop,
            'lang'  => $this->idLang,
            'key'   => SniperCommon::getConfig('sniper_key', $this->idShop, $this->idLang),
            'name' => SniperCommon::getConfig('sniper_index_name', $this->idShop, $this->idLang),
            'body' => $orderNotification['name'],
            'user_tokens' => implode(',', $customerTokens)
        )));

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $res = curl_exec($ch);
        curl_close($ch);
        $res = Tools::jsonDecode($res, true);

        return $res;
    }

    public function setMessageId($idNotification, $idShop, $idMessage)
    {
        $sql = "UPDATE "._DB_PREFIX_."sniperfast_app_notification
            SET message_id = '".pSQL($idMessage)."'".
            " WHERE id_notification = ".(int)$idNotification.
            " AND id_shop = ".(int)$idShop;
        return Db::getInstance()->execute($sql);
    }

    public function setOrderMessageId($idNotification, $idShop, $idMessage)
    {
        $sql = "UPDATE "._DB_PREFIX_."sniperfast_app_notification_order
            SET message_id = '".pSQL($idMessage)."'".
            " WHERE id_notification_order = ".(int)$idNotification.
            " AND id_shop = ".(int)$idShop;
        return Db::getInstance()->execute($sql);
    }

    public function getCustomerToken($idShop, $idCustomer)
    {
        $customerTokens = array();
        $sql = "SELECT token FROM "._DB_PREFIX_."sniperfast_app_token
            WHERE id_shop = ".(int)$idShop.
            " AND id_customer = ".(int)$idCustomer;
        $res = Db::getInstance()->executeS($sql);

        if (!empty($res)) {
            foreach ($res as $r) {
                $customerTokens[] = $r['token'];
            }
        }
        return $customerTokens;
    }
}
