<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

$db = Db::getInstance();
$p = _DB_PREFIX_;

$sql = array(
    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_conf` (
        `conf_key` VARCHAR(64) NOT NULL DEFAULT '0' COLLATE 'utf8_unicode_ci',
        `id_shop` INT(11) NOT NULL DEFAULT '1',
        `id_lang` INT(11) NOT NULL DEFAULT '1',
        `conf_value` VARCHAR(255) NULL DEFAULT '0' COLLATE 'utf8_unicode_ci',
        PRIMARY KEY (`conf_key`, `id_shop`, `id_lang`)
    ) COLLATE='utf8_unicode_ci' ENGINE=InnoDB",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_category` (
      `id_category` int(11) NOT NULL,
      `id_shop` int(11) NOT NULL DEFAULT '1',
      `endpoint` INT(11) NOT NULL DEFAULT '1',
      `boost` INT(11) NOT NULL DEFAULT '1',
      `enabled` tinyint(1) unsigned NOT NULL DEFAULT '1',
      `updated_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
      PRIMARY KEY (`id_category`,`id_shop`, `endpoint`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_manufacturer` (
      `id_manufacturer` int(11) NOT NULL,
      `id_shop` int(11) NOT NULL DEFAULT '1',
      `endpoint` INT(11) NOT NULL DEFAULT '1',
      `boost` INT(11) NOT NULL DEFAULT '1',
      `enabled` tinyint(1) unsigned NOT NULL DEFAULT '1',
      `updated_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
      PRIMARY KEY (`id_manufacturer`,`id_shop`, `endpoint`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_product` (
      `id_product` int(11) NOT NULL,
      `id_shop` int(11) NOT NULL DEFAULT '1',
      `endpoint` INT(11) NOT NULL DEFAULT '1',
      `boost` INT(11) NOT NULL DEFAULT '1',
      `enabled` tinyint(1) unsigned NOT NULL DEFAULT '1',
      `updated_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
      PRIMARY KEY (`id_product`,`id_shop`, `endpoint`)
    ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_supplier` (
      `id_supplier` int(11) NOT NULL,
      `id_shop` int(11) NOT NULL DEFAULT '1',
      `endpoint` INT(11) NOT NULL DEFAULT '1',
      `boost` INT(11) NOT NULL DEFAULT '1',
      `enabled` tinyint(1) unsigned NOT NULL DEFAULT '1',
      `updated_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
      PRIMARY KEY (`id_supplier`,`id_shop`, `endpoint`)
  ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci",

  "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_queue` (
      `id_product` INT(11) NOT NULL DEFAULT '1',
      `id_shop` int(11) NOT NULL DEFAULT '1',
      `updated_on` int(11) NOT NULL DEFAULT '0',
      PRIMARY KEY (`id_product`,`id_shop`)
  ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app` (
        `id_shop` int(11) NOT NULL DEFAULT '1',
        `conf_key` VARCHAR(64) NOT NULL DEFAULT '0' COLLATE 'utf8_unicode_ci',
        `conf_value` VARCHAR(255) NULL DEFAULT '0' COLLATE 'utf8_unicode_ci',
    PRIMARY KEY (`id_shop`, `conf_key`)
    ) COLLATE='utf8_unicode_ci' ENGINE=InnoDB",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_banner` (
    	`id_banner` INT(11) NOT NULL AUTO_INCREMENT,
        `id_shop` INT(11) NOT NULL DEFAULT '1',
    	`id_lang` INT(11) NOT NULL DEFAULT '1',
    	`name` VARCHAR(255) NULL DEFAULT '',
    	`image` VARCHAR(255) NULL DEFAULT '',
    	`position` INT(11) NOT NULL DEFAULT '1',
    	`source` INT(11) NOT NULL DEFAULT '1',
        `source_data` VARCHAR(255) NULL DEFAULT NULL,
    	`random` TINYINT(1) UNSIGNED NOT NULL DEFAULT '0',
    	`enabled` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
    	PRIMARY KEY (`id_banner`)
    ) COLLATE='utf8_general_ci' ENGINE=InnoDB",
    
    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_orders` (
        `id_order` INT(11) NOT NULL,
        `id_shop` INT(11) NOT NULL DEFAULT '1',
        PRIMARY KEY (`id_order`, `id_shop`)
    ) COLLATE='utf8_unicode_ci' ENGINE=InnoDB",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_slider` (
    	`id_slider` INT(11) NOT NULL AUTO_INCREMENT,
        `id_shop` INT(11) NOT NULL DEFAULT '1',
    	`id_lang` INT(11) NOT NULL DEFAULT '1',
    	`name` VARCHAR(255) NULL DEFAULT '',
    	`position` INT(11) NOT NULL DEFAULT '1',
    	`source` INT(11) NOT NULL DEFAULT '1',
        `source_data` VARCHAR(255) NULL DEFAULT NULL,
    	`random` TINYINT(1) UNSIGNED NOT NULL DEFAULT '0',
    	`enabled` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
    	PRIMARY KEY (`id_slider`)
    ) COLLATE='utf8_general_ci' ENGINE=InnoDB",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_notification` (
        `id_notification` INT(11) NOT NULL AUTO_INCREMENT,
        `id_shop` INT(11) NOT NULL DEFAULT '1',
        `id_lang` INT(11) NOT NULL DEFAULT '1',
        `topic` VARCHAR(255) NOT NULL,
        `device` INT(11) NOT NULL DEFAULT '0',
        `title` VARCHAR(255) NOT NULL,
        `body` VARCHAR(255) NOT NULL,
        `time` DATETIME NULL DEFAULT NULL,
        `enabled` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
        `message_id` VARCHAR(64) NULL DEFAULT NULL,
        PRIMARY KEY (`id_notification`)
    ) COLLATE='utf8_general_ci' ENGINE=InnoDB",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_notification_order` (
    	`id_notification_order` INT(11) NOT NULL AUTO_INCREMENT,
        `id_shop` INT(11) NOT NULL DEFAULT '1',
    	`id_lang` INT(11) NOT NULL DEFAULT '1',
        `status` INT(11) NOT NULL DEFAULT '1',
    	`name` VARCHAR(255) NOT NULL,
        `time` VARCHAR(8) NULL DEFAULT NULL,
        `enabled` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
        `message_id` VARCHAR(64) NULL DEFAULT NULL,
    	PRIMARY KEY (`id_notification_order`)
    ) COLLATE='utf8_general_ci' ENGINE=InnoDB",

    "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_token` (
        `id_shop` INT(11) NOT NULL DEFAULT '1',
        `id_customer` INT(11) NOT NULL DEFAULT '1',
        `token` VARCHAR(255) NOT NULL COLLATE 'utf8_unicode_ci',
        `device` VARCHAR(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
        PRIMARY KEY (`id_shop`, `id_customer`, `token`)
    ) COLLATE='utf8_unicode_ci' ENGINE=InnoDB"
);

foreach ($sql as $query) {
    if (!$db->query($query)) {
        $db->displayError(true);
    }
}
