<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2015 - 2020 Prestalia
*  @license   Commercial
*/

spl_autoload_register(function ($class) {
    $baseNamespace = 'Prestalia\\';
    $baseDir = dirname(__FILE__).'/';

    // if class name does not contain the base namespace then skip it
    $baseNamespaceLen = strlen($baseNamespace);
    if (strncmp($baseNamespace, $class, $baseNamespaceLen) !== 0) {
        return;
    }

    // convert namespace path to directory path
    $relClass = substr($class, $baseNamespaceLen);
    $file = $baseDir . str_replace('\\', '/', $relClass) . '.php';

    // if the file exists, require it
    if (file_exists($file)) {
        require $file;
    }
});
