<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

require_once dirname(__FILE__).'/../autoload.php';

function upgrade_module_1_0_1($module)
{
    $filesToRemove = array(
        '/views/css/1.085d41c1.chunk.css',
        '/views/css/front_00012.css',
        '/views/css/main.40c743df.chunk.css',
        '/views/js/1.f5001b6e.chunk.js',
        '/views/js/front_00012.js',
        '/views/js/main_en.js',
        '/views/js/main_it.js',
        '/views/js/runtime~main.229c360f.js',
        '/views/templates/front/data_16.tpl',
        '/views/templates/front/searchBar_16.tpl',
        '/views/templates/front/searchBar_17.tpl'
    );
    
    $modulePath = _PS_MODULE_DIR_.'sniperfast';
    foreach ($filesToRemove as $f) {
        if (file_exists($modulePath.$f)) {
            unlink($modulePath.$f);
        }
    }
    
    $sql = "SELECT conf_value
        FROM "._DB_PREFIX_."sniperfast_conf
        WHERE conf_key = 'main_data_file'";
    $previousJs = Db::getInstance()->executeS($sql);
    if (!empty($previousJs)) {
        foreach ($previousJs as $f) {
            if (file_exists($modulePath.'/views/js/'.$f['conf_value'].'.js')) {
                unlink($modulePath.'/views/js/'.$f['conf_value'].'.js');
            }
        }
    }
    
    if (Tools::version_compare(_PS_VERSION_, '1.7.0.0', '<')) {
        $module->unregisterHook('displayFooter');
    }
    
    try {
        $res = $module->uninstallOverrides();
        file_put_contents(dirname(__FILE__).'/sniper100.txt', 'Uninstall override: '.$res."\n", FILE_APPEND);
    } catch (Exception $e) {
        file_put_contents(dirname(__FILE__).'/sniper100.txt', $e."\n", FILE_APPEND);
    }
    
    try {
        $res = $module->installOverrides();
        file_put_contents(dirname(__FILE__).'/sniper100.txt', 'Install override: '.$res."\n", FILE_APPEND);
    } catch (Exception $e) {
        file_put_contents(dirname(__FILE__).'/sniper100.txt', $e."\n", FILE_APPEND);
    }
    
    return true;
}
