<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

require_once dirname(__FILE__).'/../autoload.php';

function upgrade_module_1_1_0($module)
{
    // Remove old files
    $filesToRemove = array(
        '/views/css/front_jq103.css',
        '/views/js/front_jq103.js',
        '/views/templates/front/searchBarJq_17.tpl'
    );
    
    $modulePath = _PS_MODULE_DIR_.'sniperfast';
    foreach ($filesToRemove as $f) {
        if (file_exists($modulePath.$f)) {
            unlink($modulePath.$f);
        }
    }
    
    // Create new database tables
    $db = Db::getInstance();
    $p = _DB_PREFIX_;
    $sql = array(
        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_category` (
          `id_category` int(11) NOT NULL,
          `id_shop` int(11) NOT NULL DEFAULT '1',
          `endpoint` INT(11) NOT NULL DEFAULT '1',
          `boost` INT(11) NOT NULL DEFAULT '1',
          `enabled` tinyint(1) unsigned NOT NULL DEFAULT '1',
          `updated_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
          PRIMARY KEY (`id_category`,`id_shop`, `endpoint`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci",

        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_manufacturer` (
          `id_manufacturer` int(11) NOT NULL,
          `id_shop` int(11) NOT NULL DEFAULT '1',
          `endpoint` INT(11) NOT NULL DEFAULT '1',
          `boost` INT(11) NOT NULL DEFAULT '1',
          `enabled` tinyint(1) unsigned NOT NULL DEFAULT '1',
          `updated_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
          PRIMARY KEY (`id_manufacturer`,`id_shop`, `endpoint`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci",

        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_product` (
          `id_product` int(11) NOT NULL,
          `id_shop` int(11) NOT NULL DEFAULT '1',
          `endpoint` INT(11) NOT NULL DEFAULT '1',
          `boost` INT(11) NOT NULL DEFAULT '1',
          `enabled` tinyint(1) unsigned NOT NULL DEFAULT '1',
          `updated_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
          PRIMARY KEY (`id_product`,`id_shop`, `endpoint`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci",

        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_supplier` (
          `id_supplier` int(11) NOT NULL,
          `id_shop` int(11) NOT NULL DEFAULT '1',
          `endpoint` INT(11) NOT NULL DEFAULT '1',
          `boost` INT(11) NOT NULL DEFAULT '1',
          `enabled` tinyint(1) unsigned NOT NULL DEFAULT '1',
          `updated_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
          PRIMARY KEY (`id_supplier`,`id_shop`, `endpoint`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci"
    );
    $res = true;
    try {
        foreach ($sql as $query) {
            $res &= $db->execute($query);
        }
    } catch (PrestashopDatabaseException $ex) {
        file_put_contents(dirname(__FILE__).'/sniper110.txt', $ex->getMessage()."\n", FILE_APPEND);
    }

    // Update Search override
    try {
        $res = $module->uninstallOverrides();
        file_put_contents(dirname(__FILE__).'/sniper110.txt', 'Uninstall override: '.$res."\n", FILE_APPEND);
    } catch (Exception $e) {
        file_put_contents(dirname(__FILE__).'/sniper110.txt', $e."\n", FILE_APPEND);
    }

    // Update js files
    $context = Context::getContext();
    $sniperUpgradeHelper = new SniperUpgradeHelper($context->shop->id);
    $sniperUpgradeHelper->updateMainData110();

    return true;
}
