<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

require_once dirname(__FILE__).'/../autoload.php';

function upgrade_module_1_3_1($module)
{
    // Remove old files
    $filesToRemove = array(
        '/views/css/back_110.css',
        '/views/js/back_110.js',
        '/views/js/back_125.js'
    );

    $modulePath = _PS_MODULE_DIR_.'sniperfast';
    foreach ($filesToRemove as $f) {
        if (file_exists($modulePath.$f)) {
            unlink($modulePath.$f);
        }
    }

    // Create new database tables
    $db = Db::getInstance();
    $p = _DB_PREFIX_;
    $sql = array(
        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_queue` (
          `id_product` INT(11) NOT NULL DEFAULT '1',
          `id_shop` int(11) NOT NULL DEFAULT '1',
          `updated_on` int(11) NOT NULL DEFAULT '0',
          PRIMARY KEY (`id_product`,`id_shop`)
        ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci"
    );
    $res = true;
    try {
        foreach ($sql as $query) {
            $res &= $db->execute($query);
        }
    } catch (PrestashopDatabaseException $ex) {
        file_put_contents(dirname(__FILE__).'/sniper131.txt', $ex->getMessage()."\n", FILE_APPEND);
    }

    // Install hook
    $module->registerHook('actionProductAdd');
    $module->registerHook('actionProductAttributeUpdate');
    $module->registerHook('actionProductUpdate');

    return true;
}
