<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

require_once dirname(__FILE__).'/../autoload.php';

function upgrade_module_1_4_0($module)
{
    // Remove old files
    $filesToRemove = array(
        '/views/js/back_130.js'
    );

    $modulePath = _PS_MODULE_DIR_.'sniperfast';
    foreach ($filesToRemove as $f) {
        if (file_exists($modulePath.$f)) {
            unlink($modulePath.$f);
        }
    }

    // Create new database tables
    $db = Db::getInstance();
    $p = _DB_PREFIX_;
    $sql = array(
        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app` (
            `id_shop` int(11) NOT NULL DEFAULT '1',
            `conf_key` VARCHAR(64) NOT NULL DEFAULT '0' COLLATE 'utf8_unicode_ci',
            `conf_value` VARCHAR(255) NULL DEFAULT '0' COLLATE 'utf8_unicode_ci',
            PRIMARY KEY (`id_shop`, `conf_key`)
        ) COLLATE='utf8_unicode_ci' ENGINE=InnoDB",

        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_banner` (
            `id_banner` INT(11) NOT NULL AUTO_INCREMENT,
            `id_shop` INT(11) NOT NULL DEFAULT '1',
            `id_lang` INT(11) NOT NULL DEFAULT '1',
            `name` VARCHAR(255) NULL DEFAULT '',
            `image` VARCHAR(255) NULL DEFAULT '',
            `position` INT(11) NOT NULL DEFAULT '1',
            `source` INT(11) NOT NULL DEFAULT '1',
            `source_data` VARCHAR(255) NULL DEFAULT NULL,
            `random` TINYINT(1) UNSIGNED NOT NULL DEFAULT '0',
            `enabled` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
            PRIMARY KEY (`id_banner`)
        ) COLLATE='utf8_general_ci' ENGINE=InnoDB",

        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_slider` (
            `id_slider` INT(11) NOT NULL AUTO_INCREMENT,
            `id_shop` INT(11) NOT NULL DEFAULT '1',
            `id_lang` INT(11) NOT NULL DEFAULT '1',
            `name` VARCHAR(255) NULL DEFAULT '',
            `position` INT(11) NOT NULL DEFAULT '1',
            `source` INT(11) NOT NULL DEFAULT '1',
            `source_data` VARCHAR(255) NULL DEFAULT NULL,
            `random` TINYINT(1) UNSIGNED NOT NULL DEFAULT '0',
            `enabled` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
            PRIMARY KEY (`id_slider`)
        ) COLLATE='utf8_general_ci' ENGINE=InnoDB",

        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_notification` (
            `id_notification` INT(11) NOT NULL AUTO_INCREMENT,
            `id_shop` INT(11) NOT NULL DEFAULT '1',
            `id_lang` INT(11) NOT NULL DEFAULT '1',
            `topic` VARCHAR(255) NOT NULL,
            `device` INT(11) NOT NULL DEFAULT '0',
            `title` VARCHAR(255) NOT NULL,
            `body` VARCHAR(255) NOT NULL,
            `time` VARCHAR(8) NULL DEFAULT NULL,
            `enabled` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
            `message_id` VARCHAR(64) NULL DEFAULT NULL,
            PRIMARY KEY (`id_notification`)
        ) COLLATE='utf8_general_ci' ENGINE=InnoDB",

        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_notification_order` (
            `id_notification_order` INT(11) NOT NULL AUTO_INCREMENT,
            `id_shop` INT(11) NOT NULL DEFAULT '1',
            `id_lang` INT(11) NOT NULL DEFAULT '1',
            `status` INT(11) NOT NULL DEFAULT '1',
            `name` VARCHAR(255) NOT NULL,
            `time` VARCHAR(8) NULL DEFAULT NULL,
            `enabled` TINYINT(1) UNSIGNED NOT NULL DEFAULT '1',
            `message_id` VARCHAR(64) NULL DEFAULT NULL,
            PRIMARY KEY (`id_notification_order`)
        ) COLLATE='utf8_general_ci' ENGINE=InnoDB",

        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_token` (
            `id_shop` INT(11) NOT NULL DEFAULT '1',
            `id_customer` INT(11) NOT NULL DEFAULT '1',
            `token` VARCHAR(255) NOT NULL COLLATE 'utf8_unicode_ci',
            `device` VARCHAR(255) NULL DEFAULT NULL COLLATE 'utf8_unicode_ci',
            PRIMARY KEY (`id_shop`, `id_customer`, `token`)
        ) COLLATE='utf8_unicode_ci' ENGINE=InnoDB"
    );
    $res = true;
    try {
        foreach ($sql as $query) {
            $res &= $db->execute($query);
        }
    } catch (PrestashopDatabaseException $ex) {
        file_put_contents(dirname(__FILE__).'/sniper140.txt', $ex->getMessage()."\n", FILE_APPEND);
    }

    $module->registerHook('actionOrderStatusPostUpdate');

    return true;
}
