<?php
/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

require_once dirname(__FILE__).'/../autoload.php';

function upgrade_module_1_4_1($module)
{
    // Create new database tables
    $db = Db::getInstance();
    $p = _DB_PREFIX_;
    $sql = array(
        "CREATE TABLE IF NOT EXISTS `{$p}sniperfast_app_orders` (
            `id_order` INT(11) NOT NULL,
            `id_shop` INT(11) NOT NULL DEFAULT '1',
            PRIMARY KEY (`id_order`, `id_shop`)
        ) COLLATE='utf8_unicode_ci' ENGINE=InnoDB"
    );
    $res = true;
    try {
        foreach ($sql as $query) {
            $res &= $db->execute($query);
        }
    } catch (PrestashopDatabaseException $ex) {
        file_put_contents(dirname(__FILE__).'/sniper141.txt', $ex->getMessage()."\n", FILE_APPEND);
    }

    $module->registerHook('displayAdminOrderTabShip');
    $module->registerHook('OrderConfirmation');

    return true;
}
