/**
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia <prestalia.it>
*  @copyright 2019 - 2020 Prestalia
*  @license   Commercial
*/

var sniper_exportInfo = {};
var statsClicked = false;

$(document).ready(function () {
    /* Account */
    $('#submit-account').click(registerRecoverAccount);

    /* Ajax checkbox */
    $('.sniperfast-ajax-checkbox').on('click', ajaxCheckboxClick);
    $('#sniperfast_refresh_products').hide();
    $('#sniperfast_refresh_products').click(refreshModuleController);

    // Language selector
    $('#lang-selector').change(languageSelectorChange);

    // Add click event to tabs
    $('[data-tab-sniperfast]').click(tabClick);
    // Open requested tab
    var idTab = $("div.sniperfast-container-tabs a.active").attr('data-tab-sniperfast');
    if (idTab === false) {
        idTab = 1;
    }
    selectTab('main', idTab);

    // CSS
    $("#cssrules").on('change', '#sniper_result_width', showHideAlignment);
    showHideAlignment();

    // Boost
    $('#sniperfast-save-boost-prod').click({type: 'prod'}, saveBoostSettings);
    $('#sniperfast-save-boost-cat').click({type: 'cat'}, saveBoostSettings);
    $('#sniperfast-save-boost-manu').click({type: 'manu'}, saveBoostSettings);
    $('#sniperfast-save-boost-supp').click({type: 'supp'}, saveBoostSettings);

    $('#sniperfast-reset-boost-prod').click({type: 'prod'}, resetBoostSettings);
    $('#sniperfast-reset-boost-cat').click({type: 'cat'}, resetBoostSettings);
    $('#sniperfast-reset-boost-manu').click({type: 'manu'}, resetBoostSettings);
    $('#sniperfast-reset-boost-supp').click({type: 'supp'}, resetBoostSettings);

    $("input[type='radio'][name='dedi_page_enable']").change(dedicatedPageEnableChange);
    dedicatedPageEnableChange();
    $('#dedi_page_title').on('keyup', function(e){
        if (isArrowKey(event)) {
            return;
        }
        $("input[type='text'][name='dedi_page_rewrite']").val(sniperStr2url($("input[type='text'][name='dedi_page_title']").val(), 'UTF-8'));
    });
    // Fetch indexing status
    fetchIndexingStatus();

    // Statistics
    if (typeof $('#sniperfast-datepicker-start').val() !== 'undefined'  &&
        $('#sniperfast-datepicker-start')[0].type != 'date'
    ) {
        $('#sniperfast-datepicker-start').datepicker();
    }
    initStatsTab();

    initAppTab();
    $('#submit_form_app').click(saveAppSettings);

    $("#sniperfast-groupleft-menu").on('click', 'a[data-tab-sniperfast="10"]', function(){
        if (!statsClicked) {
            var success = fetchStats('country');
            if (success) {
                fetchStats();
                statsClicked = true;
                $("#select-country").closest('.row').hide();
                $("#sniperfast-datepicker-start").closest('.row').hide();
            }
        }
    });

    $("#save-stats-filter").click(saveStatsOptions);
    $("#submit-filter").click(function(){
        var success = fetchStats('country');
        if (success) {
            fetchStats();
        }
    });
    $('.sniper-panel-statistics').on('change', '#select-source', resetStatisticTables);

    /* Export btn */
    $('#btn-export').click(exportBtnClick);

    /* App */
    $('#app-template-load-default').click(loadDefaultTemplateValues);
    $("#app-template-name").change(loadTemplateValues);
    if (typeof $('#app_banner_source').val() !== 'undefined') {
        $('#app_banner_source').change(handleBannerSourceData);
        handleBannerSourceData();
    }
    if (typeof $('#app_slider_source').val() !== 'undefined') {
        $('#app_slider_source').change(handleSliderSourceData);
        handleSliderSourceData();
    }
});

function tabClick(event)
{
    selectTab(
        $(this).parents('[data-container-sniperfast]').attr('data-container-sniperfast'),
        $(this).attr('data-tab-sniperfast')
    );
}

function selectTab(tabContainer, idTab)
{
    $('[data-container-sniperfast="' + tabContainer + '"] [data-content-sniperfast]').hide();
    $('[data-container-sniperfast="' + tabContainer + '"] [data-tab-sniperfast]').removeClass('active');
    $('[data-container-sniperfast="' + tabContainer + '"] [data-tab-sniperfast="' + idTab + '"]').addClass('active');
    $('[data-container-sniperfast="' + tabContainer + '"] [data-content-sniperfast="' + idTab + '"]').show();
}

function registerRecoverAccount()
{
    $.ajax({
        url: sniper_save_url,
        method: 'POST',
        data: {
            shop:   sniper_shop_id,
            lang:   $("#lang-selector").val(),
            type: 'account',
            token: sniper_token
        }
    }).done(function (data) {
        sniper_alert_data(sniper_account_ok, 'n');
        refreshModuleController();
    }).fail(function () {
        sniper_alert_data(sniper_account_error, 'e');
    });
}

function initStatsTab()
{
    $('#step-termres').hide();
    $('#step-termnores').hide();
    $('#step-totalsearch').hide();
    $('#step-prodclick').hide();
    $('#sniperfast-show-countries').closest('li').addClass('active');
    $('#sniperfast-show-countries').on('click', function(){
        showStep(1);
        return false;
    });
    $('#sniperfast-show-termres').on('click', function(){
        showStep(2);
        return false;
    });
    $('#sniperfast-show-termnores').on('click', function(){
        showStep(3);
        return false;
    });
    $('#sniperfast-show-totalsearch').on('click', function(){
        showStep(4);
        return false;
    });
    $('#sniperfast-show-prodclick').on('click', function(){
        showStep(5);
        return false;
    });
}

function initAppTab()
{
    $('#step-app-template-details').hide();
    $('#sniperfast-app-template-general').closest('li').addClass('active');
    $('#sniperfast-app-template-general').on('click', function(){
        showStepApp(1);
        return false;
    });
    $('#sniperfast-app-template-details').on('click', function(){
        showStepApp(2);
        return false;
    });
}

function showStep(step)
{
    switch (step) {
        case 1:
            $('#step-termres').hide();
            $('#step-termnores').hide();
            $('#step-totalsearch').hide();
            $('#step-prodclick').hide();
            $('#step-countries').show();
            $("#select-country").closest('.row').hide();
            $("#sniperfast-datepicker-start").closest('.row').hide();
            $('#sniperfast-show-countries').closest('li').addClass('active');
            $('#sniperfast-show-termres').closest('li').removeClass('active');
            $('#sniperfast-show-termnores').closest('li').removeClass('active');
            $('#sniperfast-show-totalsearch').closest('li').removeClass('active');
            $('#sniperfast-show-prodclick').closest('li').removeClass('active');
            $('.sniper-stat-option').show();
            break;
        case 2:
            $('#step-countries').hide();
            $('#step-termnores').hide();
            $('#step-totalsearch').hide();
            $('#step-prodclick').hide();
            $('#step-termres').show();
            $("#select-country").closest('.row').show();
            $("#sniperfast-datepicker-start").closest('.row').show();
            $('#sniperfast-show-termres').closest('li').addClass('active');
            $('#sniperfast-show-countries').closest('li').removeClass('active');
            $('#sniperfast-show-termnores').closest('li').removeClass('active');
            $('#sniperfast-show-totalsearch').closest('li').removeClass('active');
            $('#sniperfast-show-prodclick').closest('li').removeClass('active');
            $('.sniper-stat-option').hide();
            break;
        case 3:
            $('#step-countries').hide();
            $('#step-termres').hide();
            $('#step-totalsearch').hide();
            $('#step-prodclick').hide();
            $('#step-termnores').show();
            $("#select-country").closest('.row').show();
            $("#sniperfast-datepicker-start").closest('.row').show();
            $('#sniperfast-show-termnores').closest('li').addClass('active');
            $('#sniperfast-show-countries').closest('li').removeClass('active');
            $('#sniperfast-show-termres').closest('li').removeClass('active');
            $('#sniperfast-show-totalsearch').closest('li').removeClass('active');
            $('#sniperfast-show-prodclick').closest('li').removeClass('active');
            $('.sniper-stat-option').hide();
            break;
        case 4:
            $('#step-countries').hide();
            $('#step-termnores').hide();
            $('#step-termres').hide();
            $('#step-prodclick').hide();
            $('#step-totalsearch').show();
            $("#select-country").closest('.row').show();
            $("#sniperfast-datepicker-start").closest('.row').show();
            $('#sniperfast-show-totalsearch').closest('li').addClass('active');
            $('#sniperfast-show-countries').closest('li').removeClass('active');
            $('#sniperfast-show-termnores').closest('li').removeClass('active');
            $('#sniperfast-show-termres').closest('li').removeClass('active');
            $('#sniperfast-show-prodclick').closest('li').removeClass('active');
            $('.sniper-stat-option').hide();
            break;
        case 5:
            $('#step-countries').hide();
            $('#step-termnores').hide();
            $('#step-termres').hide();
            $('#step-totalsearch').hide();
            $('#step-prodclick').show();
            $("#select-country").closest('.row').show();
            $("#sniperfast-datepicker-start").closest('.row').show();
            $('#sniperfast-show-prodclick').closest('li').addClass('active');
            $('#sniperfast-show-countries').closest('li').removeClass('active');
            $('#sniperfast-show-termnores').closest('li').removeClass('active');
            $('#sniperfast-show-termres').closest('li').removeClass('active');
            $('#sniperfast-show-totalsearch').closest('li').removeClass('active');
            $('.sniper-stat-option').hide();
            break;
    }
    return false;
}

function showStepApp(step)
{
    switch (step) {
        case 1:
            $('#step-app-template-details').hide();
            $('#step-app-template-general').show();
            $('#sniperfast-app-template-general').closest('li').addClass('active');
            $('#sniperfast-app-template-details').closest('li').removeClass('active');
            break;
        case 2:
        $('#step-app-template-general').hide();
        $('#step-app-template-details').show();
        $('#sniperfast-app-template-details').closest('li').addClass('active');
        $('#sniperfast-app-template-general').closest('li').removeClass('active');
            break;
    }
    return false;
}

function loadDefaultTemplateValues()
{
    $.ajax({
        url: sniper_save_app_url,
        method: 'POST',
        data: {
            shop:   sniper_shop_id,
            lang:   $("#lang-selector").val(),
            type: 'app_tpl_load_default',
            token: sniper_token,
            tpl: $('#app-template-name').val()
        }
    }).done(function (data) {
        $.each(data.result, function(i, item) {
            $('#'+i).val(item);
        });
        updateTemplateValuesColor();
        sniper_alert_data(sniper_data_saved, 'n');
    }).fail(function () {
        sniper_alert_data(sniper_data_save_error, 'e');
    });
}

function loadTemplateValues()
{
    $.ajax({
        url: sniper_save_app_url,
        method: 'POST',
        data: {
            shop:   sniper_shop_id,
            lang:   $("#lang-selector").val(),
            type: 'app_tpl_load',
            token: sniper_token,
            tpl: $('#app-template-name').val()
        }
    }).done(function (data) {
        $.each(data.result, function(i, item) {
            $('#'+i).val(item);
        });
        updateTemplateValuesColor();
        sniper_alert_data(sniper_data_saved, 'n');
    }).fail(function () {
        sniper_alert_data(sniper_data_save_error, 'e');
    });
}

function updateTemplateValuesColor()
{
    $('.app_tpl_color').each(function(i, item){
        $(item).css('background-color', $(this).val());
    });
}

function saveAppSettings(e)
{
    e.preventDefault();
    var appConf = {};
    $('.sniper-panel-app .app_tpl_color').each(function(i, item) {
        appConf[$(item).attr('id')] = $(item).val();
    });

    $.ajax({
        url: sniper_save_app_url,
        method: 'POST',
        data: {
            shop: sniper_shop_id,
            lang: $("#lang-selector").val(),
            app_conf: appConf,
            style: $('#app-template-name').val(),
            type: 'app_conf',
            token: sniper_token
        }
    }).done(function (data) {
        sniper_alert_data(sniper_data_saved, 'n');
    }).fail(function () {
        sniper_alert_data(sniper_data_save_error, 'e');
    });
}

function showHideAlignment()
{
    var currentWidth = $("#sniper_result_width").val();
    if (currentWidth == 100) {
        $("#sniper_result_align").closest('.form-group').hide();
    } else {
        $("#sniper_result_align").closest('.form-group').show();
    }
}

function dedicatedPageEnableChange()
{
    var textValues = ['dedi_page_title', 'dedi_page_rewrite'];
    if ($("#dedi_page_enable_on").is(':checked')) {
        $.each(textValues, function(i, item){
            $("input[type='text'][name='"+ item +"']").parents('.form-group').show();
        });
    } else {
        $.each(textValues, function(i, item){
            $("input[type='text'][name='"+ item +"']").parents('.form-group').hide();
        });
    }
}

function sniperStr2url(str, encoding, ucfirst)
{
	str = str.toUpperCase();
	str = str.toLowerCase();
    /* Lowercase */
    str = str.replace(/[\u00E0\u00E1\u00E2\u00E3\u00E4\u00E5\u0101\u0103\u0105\u0430]/g, 'a');
    str = str.replace(/[\u0431]/g, 'b');
    str = str.replace(/[\u00E7\u0107\u0109\u010D\u0446]/g, 'c');
    str = str.replace(/[\u010F\u0111\u0434]/g, 'd');
    str = str.replace(/[\u00E8\u00E9\u00EA\u00EB\u0113\u0115\u0117\u0119\u011B\u0435\u044D]/g, 'e');
    str = str.replace(/[\u0444]/g, 'f');
    str = str.replace(/[\u011F\u0121\u0123\u0433\u0491]/g, 'g');
    str = str.replace(/[\u0125\u0127]/g, 'h');
    str = str.replace(/[\u00EC\u00ED\u00EE\u00EF\u0129\u012B\u012D\u012F\u0131\u0438\u0456]/g, 'i');
    str = str.replace(/[\u0135\u0439]/g, 'j');
    str = str.replace(/[\u0137\u0138\u043A]/g, 'k');
    str = str.replace(/[\u013A\u013C\u013E\u0140\u0142\u043B]/g, 'l');
    str = str.replace(/[\u043C]/g, 'm');
    str = str.replace(/[\u00F1\u0144\u0146\u0148\u0149\u014B\u043D]/g, 'n');
    str = str.replace(/[\u00F2\u00F3\u00F4\u00F5\u00F6\u00F8\u014D\u014F\u0151\u043E]/g, 'o');
    str = str.replace(/[\u043F]/g, 'p');
    str = str.replace(/[\u0155\u0157\u0159\u0440]/g, 'r');
    str = str.replace(/[\u015B\u015D\u015F\u0161\u0441]/g, 's');
    str = str.replace(/[\u00DF]/g, 'ss');
    str = str.replace(/[\u0163\u0165\u0167\u0442]/g, 't');
    str = str.replace(/[\u00F9\u00FA\u00FB\u00FC\u0169\u016B\u016D\u016F\u0171\u0173\u0443]/g, 'u');
    str = str.replace(/[\u0432]/g, 'v');
    str = str.replace(/[\u0175]/g, 'w');
    str = str.replace(/[\u00FF\u0177\u00FD\u044B]/g, 'y');
    str = str.replace(/[\u017A\u017C\u017E\u0437]/g, 'z');
    str = str.replace(/[\u00E6]/g, 'ae');
    str = str.replace(/[\u0447]/g, 'ch');
    str = str.replace(/[\u0445]/g, 'kh');
    str = str.replace(/[\u0153]/g, 'oe');
    str = str.replace(/[\u0448]/g, 'sh');
    str = str.replace(/[\u0449]/g, 'ssh');
    str = str.replace(/[\u044F]/g, 'ya');
    str = str.replace(/[\u0454]/g, 'ye');
    str = str.replace(/[\u0457]/g, 'yi');
    str = str.replace(/[\u0451]/g, 'yo');
    str = str.replace(/[\u044E]/g, 'yu');
    str = str.replace(/[\u0436]/g, 'zh');

    /* Uppercase */
    str = str.replace(/[\u0100\u0102\u0104\u00C0\u00C1\u00C2\u00C3\u00C4\u00C5\u0410]/g, 'A');
    str = str.replace(/[\u0411]/g, 'B');
    str = str.replace(/[\u00C7\u0106\u0108\u010A\u010C\u0426]/g, 'C');
    str = str.replace(/[\u010E\u0110\u0414]/g, 'D');
    str = str.replace(/[\u00C8\u00C9\u00CA\u00CB\u0112\u0114\u0116\u0118\u011A\u0415\u042D]/g, 'E');
    str = str.replace(/[\u0424]/g, 'F');
    str = str.replace(/[\u011C\u011E\u0120\u0122\u0413\u0490]/g, 'G');
    str = str.replace(/[\u0124\u0126]/g, 'H');
    str = str.replace(/[\u0128\u012A\u012C\u012E\u0130\u0418\u0406]/g, 'I');
    str = str.replace(/[\u0134\u0419]/g, 'J');
    str = str.replace(/[\u0136\u041A]/g, 'K');
    str = str.replace(/[\u0139\u013B\u013D\u0139\u0141\u041B]/g, 'L');
    str = str.replace(/[\u041C]/g, 'M');
    str = str.replace(/[\u00D1\u0143\u0145\u0147\u014A\u041D]/g, 'N');
    str = str.replace(/[\u00D3\u014C\u014E\u0150\u041E]/g, 'O');
    str = str.replace(/[\u041F]/g, 'P');
    str = str.replace(/[\u0154\u0156\u0158\u0420]/g, 'R');
    str = str.replace(/[\u015A\u015C\u015E\u0160\u0421]/g, 'S');
    str = str.replace(/[\u0162\u0164\u0166\u0422]/g, 'T');
    str = str.replace(/[\u00D9\u00DA\u00DB\u00DC\u0168\u016A\u016C\u016E\u0170\u0172\u0423]/g, 'U');
    str = str.replace(/[\u0412]/g, 'V');
    str = str.replace(/[\u0174]/g, 'W');
    str = str.replace(/[\u0176\u042B]/g, 'Y');
    str = str.replace(/[\u0179\u017B\u017D\u0417]/g, 'Z');
    str = str.replace(/[\u00C6]/g, 'AE');
    str = str.replace(/[\u0427]/g, 'CH');
    str = str.replace(/[\u0425]/g, 'KH');
    str = str.replace(/[\u0152]/g, 'OE');
    str = str.replace(/[\u0428]/g, 'SH');
    str = str.replace(/[\u0429]/g, 'SHH');
    str = str.replace(/[\u042F]/g, 'YA');
    str = str.replace(/[\u0404]/g, 'YE');
    str = str.replace(/[\u0407]/g, 'YI');
    str = str.replace(/[\u0401]/g, 'YO');
    str = str.replace(/[\u042E]/g, 'YU');
    str = str.replace(/[\u0416]/g, 'ZH');

    str = str.toLowerCase();

    str = str.replace(/[^a-z0-9\s\'\:\/\[\]-]/g,'');
	str = str.replace(/[\u0028\u0029\u0021\u003F\u002E\u0026\u005E\u007E\u002B\u002A\u002F\u003A\u003B\u003C\u003D\u003E]/g, '');
	str = str.replace(/[\s\'\:\/\[\]-]+/g, ' ');

	// Add special char not used for url rewrite
	str = str.replace(/[ ]/g, '-');
	str = str.replace(/[\/\\"'|,;%]*/g, '');

	if (ucfirst == 1) {
		var first_char = str.charAt(0);
		str = first_char.toUpperCase()+str.slice(1);
	}

	return str;
}

function saveStatsOptions()
{
    $.ajax({
        url: sniper_save_url,
        method: 'POST',
        data: {
            shop:   sniper_shop_id,
            lang:   $("#lang-selector").val(),
            excluded_ips: $('#sniperfast-ip-exclusion').val(),
            type: 'save_stats_settings',
            token: sniper_token,
        }
    }).done(function (data) {
        $('#sniperfast-ip-exclusion').val(data.result);
        sniper_alert_data(sniper_data_ipok, 'n');
    }).fail(function () {
        sniper_alert_data(sniper_data_save_error, 'e');
    });
}

function fetchIndexingStatus()
{
    if (typeof last_job_id === 'undefined' || last_job_id == '') {
        return false;
    }
    $.ajax({
        url: sniper_search_url+'?id_job='+last_job_id,
        method: 'POST',
        data: {
            shop:   sniper_shop_id,
            lang:   $("#lang-selector").val(),
            key:    sniper_key,
            index:  sniper_index_name,
            token:  sniper_token,
            ip:     sniper_source_ip
        }
    }).done(function (data) {
        switch (data.status) {
            case 'pending':
                $("#gen-index-status").text(sniper_index_pending);
                $("#gen-add-on").text(data.date_add);
                break;
            case 'not found':
                $("#gen-index-status").text(sniper_index_notfound);
                break;
            case 'completed':
                $("#gen-index-status").text(sniper_index_completed);
                $("#gen-elab-prod").text(data.number_of_entities);
                $("#gen-elab-time").text(data.time_elapsed);
                $("#gen-comp-on").text(data.date_completed);
                saveFeaturesRange(data.facets);
                break;
            default:
                break;
        }
    })
}

function validateIP(ipAddress){
    var ipv4Re = new RegExp('^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(\.|$)){4}', 'i');
    if (ipv4Re.test(ipAddress)) {
        return true;
    } else {
        return false;
    }
}

function resetStatisticTables()
{
    $("#table-country tbody").empty();
    $("#table-termres tbody").empty();
    $("#table-termnores tbody").empty();
    $("#table-totalsearch tbody").empty();
    $("#table-prodclick tbody").empty();
    $("#select-country").find('option').not(':first').remove();
}

function fetchStats(type)
{
    if (type == 'country') {
        var ips = $("#sniperfast-ip-exclusion").val().trim();
        if (ips != '') {
            var ipRegex = /^(?!0)(?!.*\.$)((1?\d?\d|25[0-5]|2[0-4]\d)(\.|$)){4}$/;
            ips = ips.split(',');
            var invalidIpFound = false;
            $.each(ips, function(i, item){
                if (!validateIP(item)) {
                    invalidIpFound = true;
                    return false;
                }
            });

            if (invalidIpFound) {
                sniper_alert_data(sniper_data_iperr, 'e');
                return false;
            }
        }

        fetchCountryStats();
        return true;
    } else {
        getStatisticData('termres');
        getStatisticData('termnores');
        getStatisticData('totalsearch');
        getStatisticData('prodclick');
    }
}

function fetchCountryStats()
{
    if ($("#select-country option").length > 1) {
        return false;
    }

    var countryIso = $('#select-country').val();
    var selectedDate = $('#sniperfast-datepicker-start').val();

    $.ajax({
        // url: sniper_stats_url+'?type=countries',
        url: 'https://api.sniperfast.com/stats?type=countries',
        method: 'POST',
        data: {
            key:    sniper_key,
            index:  sniper_index_name,
            country_iso: countryIso,
            date_from: selectedDate,
            is_app: $('#select-source').val(),
            excluded_ips: $("#sniperfast-ip-exclusion").val().trim()
        }
    }).done(function (data) {
        if (typeof data.data !== 'undefined' && data.data.total_hits > 0 && data.data.countries.length > 0) {
            var countrySearchResults = '';
            var selectCountryOptions = '';
            var pieResults = [];
            $(data.data.countries).each(function(i, item) {
                var countryCode = item.key;
                var countryImg = '<img class="sniper_flag" src="'+sniper_flags + countryCode.toLowerCase() + '.svg" />';
                countrySearchResults +=
                    '<tr>' +
                        '<td>' + countryImg + ' ' + countryCode + '</td>' +
                        '<td>' + item.doc_count + '</td>' +
                        '<td>' + item.percentage + '</td>' +
                    '</tr>';
                selectCountryOptions +=
                    '<option value="'+item.key+'">' +
                        item.key +
                    '</option>';
                // var pieRes = {};
                // pieRes.label = item.key;
                // pieRes.value = item.doc_count
                // pieResults.push(pieRes);
            });
            $("#table-country tbody").empty();
            $("#table-country tbody").append(countrySearchResults);
            if ($('#select-country').length == 1) {
                $('#select-country').append(selectCountryOptions);
            }
            $('#sniper_first_day').text(selectedDate);
        } else {
            setEmptyCountryResults();
            sniper_alert_data(sniper_data_nostats, 'w');
        }

        // nv.addGraph(function() {
        //   var chart = nv.models.pieChart()
        //       .x(function(d) { return d.label })
        //       .y(function(d) { return d.value })
        //       .showLabels(true)     //Display pie labels
        //       .labelThreshold(.05)  //Configure the minimum slice size for labels to show up
        //       .labelType("percent") //Configure what type of data to show in the label. Can be "key", "value" or "percent"
        //       .donut(true)          //Turn on Donut mode. Makes pie chart look tasty!
        //       .donutRatio(0.35)     //Configure how big you want the donut hole size to be.
        //       ;
        //
        //     d3.select("#graph-countries svg")
        //         .datum(pieResults)
        //         .transition().duration(350)
        //         .call(chart);
        //
        //   return chart;
        // });
    }).fail(function () {
        setEmptyCountryResults();
        sniper_alert_data(sniper_data_nostats, 'w');
    });
}

function setEmptyCountryResults()
{
    $("#table-country tbody").empty();
    var statSearchResults =
        '<tr>' +
            '<td>-</td>' +
            '<td>-</td>' +
            '<td>-</td>' +
        '</tr>';
    $("#table-country tbody").append(statSearchResults);
}

function getStatisticData(type)
{
    var callType = '';
    switch (type) {
        case 'termres':
            callType = 'search_terms';
            break;
        case 'termnores':
            callType = 'search_terms_no_results';
            break;
        case 'totalsearch':
            callType = 'total_searches';
            // if ($('#table-totalsearch tbody tr').length > 0) {
            //     return false;
            // }
            break;
        case 'prodclick':
            callType = 'top_clicked';
            break;
    }

    var countryIso = $('#select-country').val();
    var selectedDate = $('#sniperfast-datepicker-start').val();

    $.ajax({
        // url: sniper_stats_url+'?type=countries',
        url: 'https://api.sniperfast.com/stats?type='+callType,
        method: 'POST',
        data: {
            key:    sniper_key,
            index:  sniper_index_name,
            country_iso: countryIso,
            date_from: selectedDate,
            is_app: $('#select-source').val(),
            excluded_ips: $("#sniperfast-ip-exclusion").val().trim()
        }
    }).done(function (data) {
        if (typeof data.data !== 'undefined' && data.data.total_hits > 0) {
            $("#table-" + type + " tbody").empty();
            $("#table-" + type + "-ovr tbody").empty();
            var statSearchResults = '';
            var statSearchResultsOvr = '';
            if (type != 'totalsearch' && type != 'prodclick') {
                $(data.data.searches).each(function(i, item) {
                    if (i == 10) {
                        return false;
                    }
                    statSearchResultsOvr +=
                    '<tr>' +
                        '<td>' + item.key + '</td>' +
                        '<td>' + item.doc_count + '</td>' +
                    '</tr>';
                });
                $("#table-"+type+"-ovr tbody").append(statSearchResultsOvr);
            }
            if (type != 'prodclick') {
                $(data.data.searches).each(function(i, item) {
                    if (type == 'totalsearch') {
                        item.key = item.key.replace(' 00:00:00', '');
                    }
                    statSearchResults +=
                        '<tr>' +
                            '<td>' + item.key + '</td>' +
                            '<td>' + item.doc_count + '</td>' +
                        '</tr>';
                });
                $("#table-"+type+" tbody").append(statSearchResults);
            } else {
                $.each(data.data, function(i, item) {
                    if (i == 'total_hits') {
                        return true;
                    }
                    var productDetail = '';
                    $(item.details).each(function(j, itemDetail){
                        if (j > 0) {
                            return false;
                        }
                        if (typeof itemDetail.prod_url !== 'undefined') {
                            productDetail =
                                '<a href="'+itemDetail.prod_url+'" target="_blank">' +
                                    itemDetail.title +
                                '</a>';
                        } else {
                            productDetail =
                                '<a href="#">' +
                                    itemDetail.title +
                                '</a>';
                        }
                    });
                    statSearchResults +=
                        '<tr>' +
                            '<td>' + item.id_product + '</td>' +
                            '<td>' + productDetail + '</td>' +
                            '<td>' + item.number_of_clicks + '</td>' +
                        '</tr>';
                });
                $("#table-"+type+" tbody").append(statSearchResults);
            }
        } else {
            setEmptySearchResults(type);
        }
    }).fail(function () {
        setEmptySearchResults(type)
    });
}

function setEmptySearchResults(type)
{
    $("#table-" + type + " tbody").empty();
    $("#table-" + type + "-ovr tbody").empty();

    if (type != 'prodclick') {
        var statSearchResults =
            '<tr>' +
                '<td>-</td>' +
                '<td>-</td>' +
            '</tr>';
    } else {
        var statSearchResults =
            '<tr>' +
                '<td>-</td>' +
                '<td>-</td>' +
                '<td>-</td>' +
            '</tr>';
    }

    $("#table-"+type+" tbody").append(statSearchResults);
    $("#table-"+type+"-ovr tbody").append(statSearchResults);
}

function saveFeaturesRange(rangeData)
{
    $.ajax({
        url: sniper_save_url,
        method: 'POST',
        data: {
            shop: sniper_shop_id,
            lang: $("#lang-selector").val(),
            token: sniper_token,
            type: 'f_range',
            val:  rangeData
        }
    }).done(function (data) {
        if (data.success) {
            console.log(sniper_data_saved);
        } else {
            console.log(sniper_data_save_error);
        }
    }).fail(function () {
        console.log(sniper_data_save_error);
    });
}

function exportBtnClick()
{
    if (confirm(sniper_exportAlert)) {
        resetStats();
        $('#export-info').addClass('expanded');

        $(this).addClass('disabled');
        $('#use_cron_mode').prop('disabled', true);

        setStatusMessage('working', 'working');

        ajaxExport('&restart');
    }
}

function ajaxExport(option)
{
    var url = sniper_ajaxExportUrl + option;

    if ($('#use_cron_mode').prop('checked')) {
        url += '&cron&restart';
    }

    $.ajax({
        url: url
    }).done(function (data) {
        processAjaxExportReturn(data, true);
    }).fail(function () {
        processAjaxExportReturn(null, false);
    });
}

function processAjaxExportReturn(data, success)
{
    sniper_exportInfo['cycles']++;

    if (success) {
        if (data['success'] == true) {
            if (data['msg'] == 'export_done') {
                setStatusMessage('done', 'done');
                $('#btn-export').removeClass('disabled');
                $('#use_cron_mode').prop('disabled', false);
                sendFetchRequest();
            } else if (data['msg'] == 'export_cycle_done') {
                setStatusMessage('working', 'working');
                ajaxExport('');
            } else {
                setStatusMessage('done', data['msg']);
            }

            sniper_exportInfo['time_total']        += data['time_total'];
            sniper_exportInfo['exported_csv_rows'] += data['exported_csv_rows'];
            sniper_exportInfo['skipped_price']     += data['skipped_price'];
            sniper_exportInfo['skipped_quantity']  += data['skipped_quantity'];
            sniper_exportInfo['skipped_inactive']  += data['skipped_inactive'];

            $('#export-cycles')          .html(sniper_exportInfo['cycles']);
            $('#export-total-time')      .html(sniper_exportInfo['time_total'].toFixed(3));
            $('#export-avg-time')        .html(data['time_product_avg']);
            $('#export-memory-use')      .html(data['max_used_memory']);
            $('#export-csv-rows')        .html(sniper_exportInfo['exported_csv_rows']);
            $('#export-last-id')         .html(data['last_id_product']);
            $('#export-products-count')  .html(data['products_to_export']);
            $('#export-skipped-price')   .html(sniper_exportInfo['skipped_price']);
            $('#export-skipped-quantity').html(sniper_exportInfo['skipped_quantity']);
            $('#export-skipped-inactive').html(sniper_exportInfo['skipped_inactive']);

            var processedProducts = data['skipped_already_exported']
                + data['skipped_price']
                + data['skipped_quantity']
                + data['skipped_inactive']
                + data['exported_csv_rows'];

            var progress = 100*processedProducts/data['products_to_export'];
            setProgressbarValue(progress);

        } else if (data['success'] == false) {
            if (data['msg'] == 'another_instance_running') {
                setStatusMessage('error', data['info']);
            } else {
                setStatusMessage('error', data['msg']);
            }
        }

    } else {
        setStatusMessage('error', 'cannot_execute_request');
    }
}

function resetStats()
{
    sniper_exportInfo = {
        "time_total": 0,
        "exported_csv_rows": 0,
        "skipped_price": 0,
        "skipped_quantity": 0,
        "skipped_inactive": 0,
        "cycles": 0
    };

    $('#export-cycles')          .html('--');
    $('#export-total-time')      .html('--');
    $('#export-avg-time')        .html('--');
    $('#export-memory-use')      .html('--');
    $('#export-csv-rows')        .html('--');
    $('#export-last-id')         .html('--');
    $('#export-products-count')  .html('--');
    $('#export-skipped-price')   .html('--');
    $('#export-skipped-quantity').html('--');
    $('#export-skipped-inactive').html('--');

    setProgressbarValue(0);
}

function setProgressbarValue(value)
{
    var bar = $('#export-progress-bar > .progress-bar-inner');
    var barWidth = $('#export-progress-bar').width();
    var newWidth = Math.round(value*barWidth/100);
    bar.width(newWidth+'px');
}

function setStatusMessage(type, message)
{
    var label = $('#export-status');
    var color = '';

    switch (type) {
        case 'done':
            color = 'green';
            break;
        case 'working':
            color = 'prestalia-green';
            break;
        case 'error':
            color = 'red';
            break;
    }

    if (message in sniper_statusText) {
        message = sniper_statusText[message];
    }

    label.html('<span class="'+color+'">'+message+'</span>');
}

function sendFetchRequest()
{
    $.ajax({
        url: sniper_search_url,
        method: 'POST',
        data: {
            shop:   sniper_shop_id,
            lang:   $("#lang-selector").val(),
            key:    sniper_key,
            index:  sniper_index_name,
            token:  sniper_token,
            ip:     sniper_source_ip,
            v: sniper_module_version
        }
    }).done(function (data) {
        if (data.status == 'ok') {
            sniper_alert_data(sniper_data_success, 'n');
            saveJobId(data.id_job);
        } else {
            sniper_alert_data(sniper_data_error, 'e');
        }
    }).fail(function () {
        sniper_alert_data(sniper_data_error, 'e');
    });
}

function saveJobId(idJob)
{
    $.ajax({
        url: sniper_save_url,
        method: 'POST',
        data: {
            shop:   sniper_shop_id,
            lang:   $("#lang-selector").val(),
            token:  sniper_token,
            type:   'save_job',
            id_job: idJob
        }
    }).done(function (data) {
        if (data.success) {
            sniper_alert_data(sniper_idjob_success, 'n');
        } else {
            sniper_alert_data(sniper_idjob_error, 'e');
        }
    }).fail(function () {
        sniper_alert_data(sniper_idjob_error, 'e');
    });
}

function detectParentDivAttribute(event)
{
    var attribute = $(event.target).closest('div').attr('id');
    if (attribute === '' || typeof attribute === 'undefined') {
        attribute = $(event.target).closest('div').attr('class');
    }
    $("#search-bar-lookup-result").text(attribute);
}

function languageSelectorChange(event)
{
    $('#lang-selector').prop('disabled', true);
    window.location.href = sniper_url_change_lang
        + '?s=' + sniper_shop_id
        + '&lang=' + $('#lang-selector').val()
        + '&b=' + encodeURIComponent(window.location.href);
}

function sniper_alert_data(message, type)
{
    if (typeof($.growl) != 'undefined') {
        switch (type) {
            case 'e':
                $.growl.error({title: '', message: message});
                break;
            case 'n':
                $.growl.notice({title: '', message: message});
                break;
            case 'w':
                $.growl.warning({title: '', message: message});
                break;
        }
    } else {
        alert('Error: '+ message);
    }
}

function refreshModuleController()
{
    window.location.href = sniper_url_change_lang
        + '?s=' + sniper_shop_id
        + '&lang=' + $('#lang-selector').val()
        + '&b=' + encodeURIComponent(window.location.href);
}

function ajaxCheckboxClick()
{
    $(this).attr('class', 'sniperfast-icon-loading fa fa-circle-o-notch fa-spin');
    var checkbox_id = $(this).attr('id');
    if (!~checkbox_id.indexOf('product')) {
        $('#sniperfast_refresh_products').show();
    }
    $.ajax({
        url: $(this).attr('sniperfast-url'),
    }).done(function (data) {
        processProductCheckboxReturn(data, true, checkbox_id);
    }).fail(function () {
        processProductCheckboxReturn(null, false, checkbox_id);
    });
}

function processProductCheckboxReturn(response, success, checkbox)
{
    if (success && response['success'] == true) {
        // Flip both status attribute and class on success
        if (response['status'] == 0) {
            $('#' + checkbox).attr('class', 'sniperfast-icon-disabled');
            $('#' + checkbox).attr('sniperfast-status', '0')
        } else {
            $('#' + checkbox).attr('class', 'sniperfast-icon-enabled');
            $('#' + checkbox).attr('sniperfast-status', '1')
        }
    } else {
        // Turn back to the old values on error
        if ($('#' + checkbox).attr('sniperfast-status') == 1) {
            $('#' + checkbox).attr('class', 'sniperfast-icon-enabled');
        } else {
            $('#' + checkbox).attr('class', 'sniperfast-icon-disabled');
        }

        // Output the error message to the console
        if (response['error']) {
            console.log('sniperfast - flipStatusProduct - Error: ' + response['error']);
        } else {
            console.log('sniperfast - flipStatusProduct - Error: cannot execute request');
        }
    }
}

function saveBoostSettings(event)
{
    var type = event.data.type;
    var pageSelector = '';
    switch (type) {
        case 'prod':
            pageSelector = '#products';
            break;
        case 'cat':
            pageSelector = '#categories';
            break;
        case 'manu':
            pageSelector = '#manufacturers';
            break;
        case 'supp':
            pageSelector = '#suppliers';
            break;
    }
    var selector = "#sniperfast-boost-"+type;
    var boost = $(selector).val();
    var elements = [];
    $(pageSelector).find('input[type="checkbox"]:checked').each(function(){
        elements.push($(this).val());
    });

    if (elements.length == 0) {
        switch (type) {
            case 'prod':
                alert(sniperfast_text_no_product_selected);
                break;
            case 'cat':
                alert(sniperfast_text_no_category_selected);
                break;
            case 'manu':
                alert(sniperfast_text_no_manufacturer_selected);
                break;
            case 'supp':
                alert(sniperfast_text_no_supplier_selected);
                break;
        }
        return false;
    }

    $.ajax({
        url: sniper_save_url,
        method: 'POST',
        data: {
            shop: sniper_shop_id,
            lang: $("#lang-selector").val(),
            token: sniper_token,
            type: 'boost',
            val:  boost,
            sel:  type,
            el: elements
        }
    }).done(function (data) {
        if (data.success) {
            sniper_alert_data(sniper_data_saved, 'n');
            var tableSelector = '';
            var boxSelector = '';
            var colSelector = 3;
            switch (type) {
                case 'prod':
                    tableSelector = '#table-product';
                    boxSelector = 'productBox[]';
                    break;
                case 'cat':
                    tableSelector = '#table-category';
                    boxSelector = 'categoryBox[]';
                    colSelector = 4;
                    break;
                case 'manu':
                    tableSelector = '#table-manufacturer';
                    boxSelector = 'manufacturerBox[]';
                    break;
                case 'supp':
                    tableSelector = '#table-supplier';
                    boxSelector = 'supplierBox[]';
                    break;
            }

            $(elements).each(function(i, item){
                $('input[name="'+boxSelector+'"][value="'+item+'"]').closest('tr').find('td:eq('+colSelector+')').text(boost);
            });
        } else {
            sniper_alert_data(sniper_data_save_error, 'e');
        }
    }).fail(function () {
        sniper_alert_data(sniper_data_save_error, 'e');
    });
}

function resetBoostSettings(event)
{
    var resConfirm = confirm(sniper_boost_reset_confirm);
    if (!resConfirm) {
        return false;
    }

    var type = event.data.type;
    $.ajax({
        url: sniper_save_url,
        method: 'POST',
        data: {
            shop: sniper_shop_id,
            lang: $("#lang-selector").val(),
            token: sniper_token,
            type: 'boost_reset',
            sel:  type
        }
    }).done(function (data) {
        if (data.success) {
            sniper_alert_data(sniper_data_saved, 'n');
            var tableSelector = '';
            var colSelector = 3;
            switch (type) {
                case 'prod':
                    tableSelector = '#table-product';
                    break;
                case 'cat':
                    tableSelector = '#table-category';
                    colSelector = 4;
                    break;
                case 'manu':
                    tableSelector = '#table-manufacturer';
                    break;
                case 'supp':
                    tableSelector = '#table-supplier';
                    break;
            }

            $(tableSelector + ' tbody tr').each(function(){
                $(this).find('td:eq('+colSelector+')').text('0');
            });
        } else {
            sniper_alert_data(sniper_data_save_error, 'e');
        }
    }).fail(function () {
        sniper_alert_data(sniper_data_save_error, 'e');
    });
}

function handleBannerSourceData()
{
    var bannerVal = $('#app_banner_source').val();
    if (bannerVal <= 1) {
        $('#app_banner_source_data').closest('.form-group').hide();
    } else {
        $('#app_banner_source_data').closest('.form-group').show();
    }
}

function handleSliderSourceData()
{
    var sliderVal = $('#app_slider_source').val();
    if (sliderVal <= 1) {
        $('#app_slider_source_data').closest('.form-group').hide();
    } else {
        $('#app_slider_source_data').closest('.form-group').show();
    }
}
