{*
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia
*  @copyright 2019 - 2020 Prestalia
*  @license   This is proprietary software thus it cannot be distributed nor reselled
*}

<div class="tab-pane panel">
<div id="sniperfast-app-settings" class="sniperfast-tab-content-border">
    <div class="panel-heading">{l s='Template' mod='sniperfast'}</div>
    <form id="app-form" class="defaultForm form-horizontal AdminSniperfast" method="post"
        enctype="multipart/form-data" novalidate>
        <div class="row">
            <div class="col-lg-12">
                <div class="sniper-panel-app sniper-panel-export">
                    <div id="app-template-selection" class="content-wrapper">
                        <div class="list-info">
                            <div class="row sniper-stat-option">
                                <div class="cell-left col-lg-3">
                                    {l s='Style' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <select id="app-template-name" class="fixed-width-xl">
                                        {foreach $availableTemplates as $templateName}
                                            <option value="{$templateName|escape:'htmlall':'UTF-8'}"{if $templateName == $selectedTemplate} selected="selected"{/if}>{$templateName|escape:'htmlall':'UTF-8'}</option>
                                        {/foreach}
                                    </select>
                                </div>
                            </div>
                            <div class="row sniper-stat-option">
                                <div class="cell-left col-lg-3"></div>
                                <div class="cell-right col-lg-9">
                                    <a class="btn btn-default input fixed-width-xl" id="app-template-load-default">{l s='Load default values' mod='sniperfast'}</a>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="appTabs">
                        <ul class="tab nav nav-tabs">
                            <li class="tab-row">
                                <a class="tab-page" id="sniperfast-app-template-general" class="app-template-label" href="#">
                                    {l s='General' mod='sniperfast'}
                                </a>
                            </li>
                            <li class="tab-row">
                                <a class="tab-page" id="sniperfast-app-template-details" class="app-template-label" href="#">
                                    {l s='Details' mod='sniperfast'}
                                </a>
                            </li>
                        </ul>
                    </div>
                    <div id="step-app-template-general">
                        <div class="list-info panel">
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Primary colors' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" name="color" id="ion-color-primary" value="{$templateColor['ion-color-primary']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-color-primary']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-color-primary" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Primary colors\' contrast' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="ion-color-primary-contrast" value="{$templateColor['ion-color-primary-contrast']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-color-primary-contrast']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-color-primary-contrast" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Secondary  colors' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="ion-color-secondary" value="{$templateColor['ion-color-secondary']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-color-secondary']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-color-secondary" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Secondary  colors\' contrast' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="ion-color-secondary-contrast" value="{$templateColor['ion-color-secondary-contrast']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-color-secondary-contrast']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-color-secondary-contrast" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Tertiary  colors' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="ion-color-tertiary" value="{$templateColor['ion-color-tertiary']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-color-tertiary']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-color-tertiary" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Tertiary  colors\' contrast' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="ion-color-tertiary-contrast" value="{$templateColor['ion-color-tertiary-contrast']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-color-tertiary-contrast']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-color-tertiary-contrast" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div id="step-app-template-details">
                        <div class="list-info panel">
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Main background' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="ion-background-color" value="{$templateColor['ion-background-color']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-background-color']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-background-color" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Main background contrast' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="ion-background-color-contrast" value="{$templateColor['ion-background-color-contrast']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-background-color-contrast']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-background-color-contrast" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Text' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="ion-text-color" value="{$templateColor['ion-text-color']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-text-color']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-text-color" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Text contrast' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="ion-text-color-contrast" value="{$templateColor['ion-text-color-contrast']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['ion-text-color-contrast']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_ion-text-color-contrast" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Price' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="price-color" value="{$templateColor['price-color']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['price-color']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_price-color" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="cell-left col-lg-3">
                                    {l s='Original price' mod='sniperfast'}
                                </div>
                                <div class="cell-right col-lg-9">
                                    <div class='input-group fixed-width-xl'>
                                        <input type="text" data-hex="true" class="color mColorPickerInput mColorPicker app_tpl_color" id="price-color-strikethrough" value="{$templateColor['price-color-strikethrough']|escape:'htmlall':'UTF-8'}" style="background-color:{$templateColor['price-color-strikethrough']|escape:'htmlall':'UTF-8'};"/>
                                        <span style="cursor:pointer;" id="icp_price-color-strikethrough" class="mColorPickerTrigger input-group-addon"
                                            data-mcolorpicker="true"><img src="/img/admin/color.png" style="border:0;margin:0 0 0 3px" align="absmiddle"></span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="panel-footer">
            <button type="submit" value="1" id="submit_form_app" name="submit_form_app" class="btn btn-default pull-right">
                <i class="process-icon-save"></i>
                {l s='Save' mod='sniperfast'}
            </button>
        </div>
    </form>
</div>
</div>
