{*
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia
*  @copyright 2019 - 2020 Prestalia
*  @license   This is proprietary software thus it cannot be distributed or reselled
*}

<script type="text/javascript">
    var sniper_ajaxExportUrl = "{$ajax_export_url|escape:'quotes':'UTF-8'}";
    var sniper_exportAlert = "{l s='Exporting will overwrite the previous exported file. Are you sure?' mod='sniperfast'}";
    var sniper_statusText = {
        "working"               : "{l s='Working...' mod='sniperfast'}",
        "done"                  : "{l s='Export done' mod='sniperfast'}",
        "cannot_execute_request": "{l s='Error: cannot execute request' mod='sniperfast'}",
        "missing_configuration" : "{l s='Error: missing configuration. Configure the module and try again' mod='sniperfast'}",
        "nothing_to_do"         : "{l s='Nothing to do' mod='sniperfast'}"
    };
    var sniper_index_pending = "{l s='Indexing request pending' mod='sniperfast'}";
    var sniper_index_notfound = "{l s='Indexing request not found' mod='sniperfast'}";
    var sniper_index_completed = "{l s='Indexing request completed' mod='sniperfast'}";
</script>

<div class="row">
        <div class="col-lg-6">
        <div class="panel sniper-panel-export">
            <div class="panel-heading">
                {l s='Export info' mod='sniperfast'}
            </div>
            <div class="content-wrapper">

                <div class="list-info">
                    <div class="row">
                        <div class="cell-left">{l s='Max execution time' mod='sniperfast'}:</div>
                        <div class="cell-right">{$max_execution_time|escape:'htmlall':'UTF-8'} {l s='seconds' mod='sniperfast'}</div>
                    </div>
                    <div class="row">
                        <div class="cell-left">{l s='Memory limit' mod='sniperfast'}:</div>
                        <div class="cell-right">{$memory_limit|escape:'htmlall':'UTF-8'}</div>
                    </div>
                    <div class="row">
                        <div class="cell-left">{l s='Output CSV directory' mod='sniperfast'}:</div>
                        <div class="cell-right">{$output_dir|escape:'htmlall':'UTF-8'}</div>
                    </div>
                    <div class="row">
                        <div class="cell-left">{l s='Directory status' mod='sniperfast'}:</div>
                        <div class="cell-right">

                            {if $dir_writable}
                                <b class="green">{l s='Directory is writable' mod='sniperfast'}</b>
                            {else}
                                <b class="red">{l s='Directory is not writable' mod='sniperfast'}. {l s='You will not be able to export your datafeed' mod='sniperfast'}</b>
                            {/if}

                        </div>
                    </div>
                    <div class="row">
                        <div class="cell-left">{l s='Last export date' mod='sniperfast'}:</div>
                        <div class="cell-right">
                            {$last_export_date|escape:'htmlall':'UTF-8'}
                        </div>
                    </div>
                    <div class="row">
                        <div class="cell-left">{l s='Last export status' mod='sniperfast'}:</div>
                        <div class="cell-right">
                            {if $last_export_status == "ok"}
                                <b class="green">{l s='OK' mod='sniperfast'}</b>
                            {elseif $last_export_status == "exports_gap_not_elapsed"}
                                <b class="green">{l s='OK. (Export routine launched more times than necessary but that\'s ok)' mod='sniperfast'}</b>
                            {elseif $last_export_status == "products_left"}
                                <b class="red">{l s='Due to server\'s limitations, CRON job was not able to complete the export.' mod='sniperfast'}</b>
                                {l s='In order to complete it run the CRON again as many times as necessary.' mod='sniperfast'}<br>
                                {l s='Increase max_execution_time on your server to see if the next export can be completed in single cycle.' mod='sniperfast'}<br>
                                {l s='If not, complete the export manually using the dedicated button down below.' mod='sniperfast'}
                            {elseif $last_export_status == "error"}
                                <b class="red">{l s='Error' mod='sniperfast'}</b>
                            {/if}
                        </div>
                    </div>
                </div>

            </div>
        </div>
    </div>
    <div class="col-lg-6">
        <div class="panel sniper-panel-export">
            <div class="panel-heading">
                {l s='Index info' mod='sniperfast'}
            </div>
            <div class="content-wrapper">
                <div class="list-info">
                    <div class="row">
                        <div class="cell-left">{l s='Indexing status' mod='sniperfast'}:</div>
                        <div class="cell-right"><span id="gen-index-status"></span></div>
                    </div>
                    <div class="row">
                        <div class="cell-left">{l s='Elaborated products' mod='sniperfast'}:</div>
                        <div class="cell-right"><span id="gen-elab-prod"></span></div>
                    </div>
                    <div class="row">
                        <div class="cell-left">{l s='Elaboration time' mod='sniperfast'}:</div>
                        <div class="cell-right"><span id="gen-elab-time"></span></div>
                    </div>
                    <div class="row">
                        <div class="cell-left">{l s='Added on' mod='sniperfast'}:</div>
                        <div class="cell-right"><span id="gen-add-on"></span></div>
                    </div>
                    <div class="row">
                        <div class="cell-left">{l s='Elaborated on' mod='sniperfast'}:</div>
                        <div class="cell-right"><span id="gen-comp-on"></span></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="panel sniper-panel-export">
    <div class="panel-heading">
        {l s='Export' mod='sniperfast'}
    </div>
    <div class="content-wrapper">

        <div class="list">
            <div class="row">
                <div class="cell-left">
                    <button class="btn btn-default {if !$dir_writable}disabled{/if}" id="btn-export">
                        <i class="process-icon-export"></i>
                        {l s='Export' mod='sniperfast'}
                    </button>
                </div>
                <div class="cell-right">
                    {l s='Export the selected products to CSV' mod='sniperfast'}<br>
                    {*
                    <input type="checkbox" id="use_cron_mode">{l s='Use CRON mode' mod='sniperfast'}</input><br><br>
                    {l s='The file will be available at the following link' mod='sniperfast'}:<br>
                    <b><a href="{$csv_url|escape:'quotes':'UTF-8'}" target="_blank">{$csv_url|escape:'htmlall':'UTF-8'}</a></b>
                    *}
                    <div class="list-info" id="export-info">
                        <div class="row">
                            <div class="cell-left">
                                {l s='Progress' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <div class="progress-bar-outer" id="export-progress-bar"><div class="progress-bar-inner"></div></div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Status' mod='sniperfast'}:
                            </div>
                            <div class="cell-right" id="export-status">
                                <span class="prestalia-green">Working...</span>
                                <span class="red">Error</span>
                                <span class="green">Export done</span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Cycles' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-cycles">--</span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Total time' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-total-time">--</span>
                                {l s='seconds' mod='sniperfast'}
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Avg time per product' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-avg-time">--</span>
                                {l s='seconds' mod='sniperfast'}
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Memory used' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-memory-use">--</span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Exported CSV rows' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-csv-rows">--</span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Last processed product ID' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-last-id">--</span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Products to export' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-products-count">--</span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Skipped products (price filter)' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-skipped-price">--</span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Skipped products (quantity filter)' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-skipped-quantity">--</span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="cell-left">
                                {l s='Skipped products (product inactive)' mod='sniperfast'}:
                            </div>
                            <div class="cell-right">
                                <span id="export-skipped-inactive">--</span>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>
</div>

<div class="panel sniper-panel-export">
    <div class="panel-heading">
        {l s='Cron - Standard mode' mod='sniperfast'}
    </div>
    <div class="content-wrapper">
        <span>{l s='In order to keep your feed updated it is highly suggested to setup a Cron' mod='sniperfast'}.</span><br>
        <span>
            {l s='With the following link the export will run as long as your server is allowed to.' mod='sniperfast'}
            &nbsp;
            {l s='If the max execution time is not enough, then you will have to configure on your server as many CRONs as required to end the process.' mod='sniperfast'}
            <br>
            {l s='Let\'s make an example: if the export does not end and your max execution time is 10 minutes long, then you will have setup a second CRON that will have to start 10 minutes after the previous one. Repeat this configuration as much as it is required.' mod='sniperfast'}
        </span><br><br>
        <span>{l s='Use this link to generate your datafeed using Cron' mod='sniperfast'}:</span><br>

        <a href="{$cron_export_url|escape:'quotes':'UTF-8'}">{$cron_export_url|escape:'htmlall':'UTF-8'}</a>
    </div>
</div>
<div class="panel sniper-panel-export">
    <div class="panel-heading">
        {l s='Cron - Advanced mode' mod='sniperfast'}
    </div>
    <div class="content-wrapper">
        <span>{l s='In order to keep your feed updated it is highly suggested to setup a Cron' mod='sniperfast'}.</span><br>
        <span>
            {l s='With the following link the export will run as much as needed even if your server resources are limited.' mod='sniperfast'}
            &nbsp;
            {l s='To reach this result it is mandatory to run the CRON in the following way. Make sure to add double quotes before and after the url, exactly as shown here.' mod='sniperfast'}
            <br><br>
            <b>curl -L --max-redirs 1000 "{$cron_export_url|escape:'htmlall':'UTF-8'}&recursive=1" > /dev/null 2>&1</b>
            <br><br>
        </span>
    </div>
</div>
