{*
*  Copyright (C) Prestalia - All Rights Reserved
*
*  Unauthorized copying of this file, via any medium is strictly prohibited
*  Proprietary and confidential
*
*  @author    Prestalia
*  @copyright 2019 - 2020 Prestalia
*  @license   This is proprietary software thus it cannot be distributed nor reselled
*}

<div class="row">
    <div class="col-lg-12">
        <div class="panel sniper-panel-statistics sniper-panel-export">
            <div class="panel-heading">{l s='Search statistics' mod='sniperfast'}</div>
            <div id="stats-filters" class="content-wrapper">
                <div class="list-info">
                    <div class="row sniper-stat-option">
                        <div class="cell-left col-lg-3">
                            {l s='Exclude searches performed by these IPs' mod='sniperfast'}
                        </div>
                        <div class="cell-right col-lg-9">
                            <input type="text" class="input" id="sniperfast-ip-exclusion" value="{$sniper_excluded_ips|escape:'htmlall':'UTF-8'}"/><br>
                            <div class="help-block">{l s='Separate each IP with a comma.' mod='sniperfast'}</div>
                        </div>
                    </div>
                    <div class="row sniper-stat-option">
                        <div class="cell-left col-lg-3"></div>
                        <div class="cell-right col-lg-9">
                            <a class="btn btn-default input fixed-width-xl" id="save-stats-filter">{l s='Save data' mod='sniperfast'}</a>
                        </div>
                    </div>
                    <hr class="sniper-stat-option">
                    <div class="row">
                        <div class="cell-left col-lg-3">
                            {l s='Source' mod='sniperfast'}
                        </div>
                        <div class="cell-right col-lg-9">
                            <select id="select-source" class="input fixed-width-xl">
                                <option value="0">{l s='Website' mod='sniperfast'}</option>
                                <option value="1">{l s='App' mod='sniperfast'}</option>
                            </select>
                        </div>
                    </div>
                    <div class="row">
                        <div class="cell-left col-lg-3">
                            {l s='Results range date' mod='sniperfast'}
                        </div>
                        <div class="cell-right col-lg-9 sniper-stat-text">
                            <span id="sniper_first_day">{$sniper_first_day|escape:'htmlall':'UTF-8'}</span> 00:00 -
                            <span id="sniper_yesterday">{$sniper_yesterday|escape:'htmlall':'UTF-8'}</span> 23:59
                        </div>
                    </div>
                    <div class="row">
                        <div class="cell-left col-lg-3">
                            {l s='Countries' mod='sniperfast'}
                        </div>
                        <div class="cell-right col-lg-9">
                            <select id="select-country" class="input fixed-width-xl">
                                <option value="">{l s='All' mod='sniperfast'}</option>
                            </select>
                        </div>
                    </div>
                    <div class="row">
                        <div class="cell-left col-lg-3">
                            {l s='Start date' mod='sniperfast'}
                        </div>
                        <div class="cell-right col-lg-9">
                            <input class="input fixed-width-xl" type="date" id="sniperfast-datepicker-start"
                            max="{$sniper_yesterday|escape:'htmlall':'UTF-8'}" value="{$sniper_first_day|escape:'htmlall':'UTF-8'}"/>
                        </div>
                    </div>
                    <div class="row">
                        <div class="cell-left col-lg-3"></div>
                        <div class="cell-right col-lg-9">
                            <a class="btn btn-default input fixed-width-xl" id="submit-filter">{l s='Update data' mod='sniperfast'}</a>
                        </div>
                    </div>
                </div>
            </div>
            <div class="statisticsTabs">
                <ul class="tab nav nav-tabs">
                    <li class="tab-row">
                        <a class="tab-page" id="sniperfast-show-countries" href="#">
                            {l s='Overview' mod='sniperfast'}
                        </a>
                    </li>
                    <li class="tab-row">
                        <a class="tab-page" id="sniperfast-show-termres" href="#">
                            {l s='Search terms' mod='sniperfast'}
                        </a>
                    </li>
                    <li class="tab-row">
                        <a class="tab-page" id="sniperfast-show-termnores" href="#">
                            {l s='Search terms - No results' mod='sniperfast'}
                        </a>
                    </li>
                    <li class="tab-row">
                        <a class="tab-page" id="sniperfast-show-totalsearch" href="#">
                            {l s='Total searches' mod='sniperfast'}
                        </a>
                    </li>
                    <li class="tab-row">
                        <a class="tab-page" id="sniperfast-show-prodclick" href="#">
                            {l s='Clicked products' mod='sniperfast'}
                        </a>
                    </li>
                </ul>
            </div>
            <div id="step-countries">
                <div class="row">
                    <div class="col-lg-12">
                        <div id="graph-countries" class="panel">
                            {*<svg>
                            </svg>*}
                            <table id="table-country">
                                <thead>
                                    <th>{l s='Country' mod='sniperfast'}</th>
                                    <th>{l s='Number of searches' mod='sniperfast'}</th>
                                    <th>{l s='% of searches' mod='sniperfast'}</th>
                                </thead>
                                <tbody>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                {*
                <div class="row">
                    <div class="col-lg-6">
                        <div id="graph-termres-ovr" class="panel">
                            <table id="table-termres-ovr">
                                <thead>
                                    <th>{l s='Terms with results' mod='sniperfast'}</th>
                                    <th>{l s='Number of searches' mod='sniperfast'}</th>
                                </thead>
                                <tbody>
                                </tbody>
                            </table>
                        </div>
                    </div>
                    <div class="col-lg-6">
                        <div id="graph-termnores-ovr" class="panel">
                            <table id="table-termnores-ovr">
                                <thead>
                                    <th>{l s='Terms with no results' mod='sniperfast'}</th>
                                    <th>{l s='Number of searches' mod='sniperfast'}</th>
                                </thead>
                                <tbody>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
                *}
            </div>
            <div id="step-termres" class="content-wrapper">
                <div class="row">
                    <div class="col-lg-12">
                        <div id="graph-termres" class="panel">
                            <table id="table-termres">
                                <thead>
                                    <th>{l s='Term' mod='sniperfast'}</th>
                                    <th>{l s='Number of searches' mod='sniperfast'}</th>
                                </thead>
                                <tbody>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <div id="step-termnores" class="content-wrapper">
                <div class="row">
                    <div class="col-lg-12">
                        <div id="graph-termnores" class="panel">
                            <table id="table-termnores">
                                <thead>
                                    <th>{l s='Term' mod='sniperfast'}</th>
                                    <th>{l s='Number of searches' mod='sniperfast'}</th>
                                </thead>
                                <tbody>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <div id="step-totalsearch" class="content-wrapper">
                <div class="row">
                    <div class="col-lg-12">
                        <div id="graph-totalsearch" class="panel">
                            <table id="table-totalsearch">
                                <thead>
                                    <th>{l s='Day' mod='sniperfast'}</th>
                                    <th>{l s='Number of searches' mod='sniperfast'}</th>
                                </thead>
                                <tbody>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <div id="step-prodclick" class="content-wrapper">
                <div class="row">
                    <div class="col-lg-12">
                        <div id="graph-prodclick" class="panel">
                            <table id="table-prodclick">
                                <thead>
                                    <th>ID</th>
                                    <th>{l s='Product' mod='sniperfast'}</th>
                                    <th>{l s='Number of clicks' mod='sniperfast'}</th>
                                </thead>
                                <tbody>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
